*H SCPELA.S
; AUTOR: Lutz Elssner
; STAND: 14.04.89
; -------------------
;;CCP-Kopie des RAM im ROM
; ========================
;alle Marken, die Adressen des ROM bezeichnen, enden mit 0
;alle Marken, die Adressen des RAM bezeichnen, enden mit 2
;alle Marken, die im ROM und im RAM die gleiche Bedeutung haben,
;unterscheiden sich nur im letzten Zeichen (0 oder 2)
; -------------------------------
CRAM0:				;ab hier wird alles in den RAM kopiert
;====================================================
;;CCP-Kommandopuffer
;=== Laenge = 01 === im RAM von Hand aendern ! ===
COMBF0:	DEFB	127		;CCP-Kommandopufferlaenge
;=== Laenge = 01 === im RAM von Hand aendern ! ===
COMBL0:	DEFB	13		;aktuelle Kommandolaenge (Wert ungleich 0)
;=== Laenge = 127 === im RAM von Hand aendern ! ===
COMBT0:	DEFM	'SUBM AUTOEXEC'	;16 Byte + 111 Byte Tabelle = 127 Byte
	DEFM	' L'		;fuellt Tabelle auf 127
	DEFB	0		;Abschlusszeichen
; -------------------------------
;;Tabelle der echten, internen residenten Kommandos, die im ROM laufen
; diese Tabelle wird im ROM benutzt, die Kopie in den RAM dient als Platzhalter
RESCI:	DEFM	'DIR     '
	DEFW	ICBED
	DEFM	'ERA     '
	DEFW	ICC66
	DEFM	'TYPE    '
	DEFW	ICC9E
	DEFM	'SAVE    '
	DEFW	ICCE7
	DEFM	'REN     '
	DEFW	ICD44
	DEFM	'USER    '
	DEFW	ICDBA
	DEFM	'EXT     '
	DEFW	EXT
	DEFM	'RES     '
	DEFW	RES
	DEFM	'SWAP    '
	DEFW	SWAP
	DEFM	'HELP    '
	DEFW	HELP
	DEFM	'GO      '
	DEFW	0		;Adresse 0 wird besonders behandelt
	DEFB	0		;Tabellenende
;===================================================================
;;FCB fuer $$$.SUB
;=== Laenge = 14 === im RAM von Hand aendern ! ===
SFD0:	DEFB	0		;Drive
	DEFM	'$$$     SUB'	;Name, Typ
	DFB	0,0		;EX, S1
;=== Laenge = 01 === im RAM von Hand aendern ! ===
SFS20:	DEFB	0		;S2   BDOS-Flag fuer Schreibzugriff
;=== Laenge = 17 === im RAM von Hand aendern ! ===
SFRC0:	DEFB	0		;RC   Record Counter
	DFB	0,0,0,0,0,0,0,0
	DFB	0,0,0,0,0,0,0,0
;=== Laenge = 04 === im RAM von Hand aendern ! ===
SFCR0:	DEFB	0		;CR   Current Record
	DFB	0,0,0		;R0...R2 (Reserve fuer Direktzugriff)
; -------------------------------
;;CCP-Programme, die im RAM abgearbeitet werden
; =============================================
;;Lesen von 2 Byte in anderem SLOT
; PPIA lesen und retten erfolgte bereits im ROM
;=== Laenge = 08 === im RAM von Hand aendern ! ===
CBCHL0:	OUT	(PPIA),A
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	JP	RTPA2
; -------------------------------
;;Blocktransfer im RAM
; PPIA lesen und retten erfolgte bereits im ROM
;=== Laenge = 07 === im RAM von Hand aendern ! ===
LDDR0:	OUT	(PPIA),A
	LDDR
	JP	RTPA2
; -------------------------------
;;BDOS-Ruf mit RAM-Belegung fuer alle BDOS-Rufe aus dem CCP-ROM
; PPIA lesen und retten erfolgte bereits im ROM
;=== Laenge = 08 === im RAM von Hand aendern ! ===
CBDR0:	OUT	(PPIA),A
	CALL	5
	JP	RTPA2
; -------------------------------
;;Adresstabelle der eigenen Fehlerbehandlungsroutinen
; wird hier nur zum Kopieren innerhalb des RAM beim Kommando EXT gebraucht
;=== Laenge = 08 === im RAM von Hand aendern ! ===
ETAB0:	DEFW	ESEC2		;bad sector
	DEFW	ESEL2		;select
	DEFW	EDRO2		;disk r/o
	DEFW	EFRO2		;file r/o
; ===============================
;
;
; Der folgende Programmteil wird hinter dem CCP-STACK abgelegt
; ============================================================
;;Blocktransfer im RAM
; PPIA lesen und retten erfolgte bereits im ROM
;=== Laenge = 04 === im RAM von Hand aendern ! ===
LDIR0:	OUT	(PPIA),A
	LDIR
; -------------------------------
; Rueckschalten Speicherkonfiguration ohne Registerveraenderung
;=== Laenge = 08 === im RAM von Hand aendern ! ===
RTPA0:	EX	(SP),HL	 	;HL retten, Slotkonf in HL
	PUSH	AF		;AF retten
	LD	A,H
	OUT	(PPIA),A        ;Speicher rueckschalten
	POP	AF		;AF regenerieren
	POP	HL		;HL regenerieren
	RET
; -------------------------------
; Rueckkehr von transientem Kommando
;=== Laenge = 08 === im RAM von Hand aendern ! ===
RET0:	LD	A,(CSLOT)	;CCP-SLOT
	OUT	(PPIA),A	;einschalten
	JP	RETPA
; Rueckkehr aus Unterprogramm, das vom Anwender im anderen SLOT gerufen wurde
;=== Laenge = 05 === im RAM von Hand aendern ! ===
ANCR0:	LD	SP,(ASTSV)
	RET
; -------------------------------
; Ansprung eines Programmes im anderen SLOT
; auf STACK muss Rueckkehradresse liegen
;=== Laenge = 03 === im RAM von Hand aendern ! ===
JPHL0:	OUT	(PPIA),A
	JP	(HL)
; -------------------------------
CCPE0:				;Ende der Kopien
; ===============================
; ENDE SCPELA.S
; ===============================
