*H SCPELO.S
; AUTOR: Lutz Elssner
; STAND: 05.05.89
; ------------------
;;CCP-ROM
; =======
; Eintrittsmoeglichkeiten:
; CCP	vom Kaltstart (Abarbeitung Kaltstartkommando SUBM AUTOEXEC)
; CCPW	vom Warmstart (Loeschen des Kommandopuffers)
; die Initialisierung des CCP-RAM erfolgt nach dem Eintritt vom Kaltstart
; automatisch
; -----------------------------------------------------------------------
; externe Marken:CRAM2
; globale Marken: CCP, CCPW
;
; -----------------------------------------------------------------------
;;CCP-EQU's
; =========
;
DEFAUL	EQU	4
;BDOSJP	erfolgt ueber RAM
BDOSAD	EQU	6		;BDOS-Adresse
DEFFCB	EQU	5CH 		;Standard-FCB
DEFDMA	EQU	80H
TPA	EQU	100H
LRESO	EQU	8		;Laenge residenter Kommando-Namen (ROM)
LRESC	EQU	8		;Laenge residenter Kommando-Namen (RAM)
NRESC	EQU	6		;Anzahl mit EXT nachladbarer Kommandos
LVOR	EQU	24		;Laenge des BDOS-Vorspanns
LADINI	EQU	16		;Adresse im BDOS-Vorspann
;
; -------------------------------
CFCBD	EQU	DEFFCB		;Disk
CFCBF	EQU	DEFFCB+1	;Filename
CFCBT	EQU	DEFFCB+9	;Typ EX S1 S2 RC
CFCB0	EQU	DEFFCB+16
CFCBCR	EQU	DEFFCB+32	;Current Record
;
*EJEC
;;CCP-Eintritt
; ============
;;Eintritt von BIOS nach Kaltstart, Initialisierung des gesamten CCP-RAM
; Abarbeitung des Kaltstartkommandos SUBM AUTOEXEC
; Uebergabeparameter in Register C:Bit 7,6,5,4=USER  Bit 3,2,1,0=DRIVE
CCP:	IN	A,(PPIA)
	AND	11111100B	;RAM fuer Adressbereich 0000-3FFF
	OR	00000010B	;einschalten
	OUT	(PPIA),A
	LD	B,A		;B=CCP-interne SLOT-Belegung
	PUSH	BC		;C=USER/DRIVE retten
; Loeschen des gesamten CCP-RAM-Bereiches
	LD	HL,CRAM2	;Anfangsadresse RAM
	LD	DE,CRAML	;Laenge
CCPK1:	LD	(HL),0
	INC	HL
	DEC	DE
	LD	A,E
	OR	D
	JR	NZ,CCPK1
;
	LD	A,B
	LD	(CSLOT),A	;CCP-interne SLOT-Belegung
; Transport der Kopie in den RAM
	CALL	CCOPY		;2* LDIR
; Initialisierung von Steuervariablen
	LD	A,0C9H		;RET fuer PATCH eintragen
	LD	(CK12),A	;Warmstart
	LD	(CK22),A	;Kommandoschleife
	LD	(CK32),A	;CCPDEF
;
	LD	HL,COMBT2
	LD	(DCF71),HL	;Parameterbeginn fuer Fehlermeldung auf Anfang
;
	LD	HL,(BDOSAD)	;BDOS-Anfang nach Kaltstart
	LD	(CBDOS),HL	;BDOS-Sprung wird bei Warmstart regeneriert
	LD	(TREND),HL	;keine Treiber nachgeladen
	LD	(EXTZ),HL	;keine EXT-Kommandos
;
	PUSH	HL		;Original-BDOS-Adresse
	LD	DE,LADINI	;auf BDOS+LADINI eintragen
	ADD	HL,DE
	POP	DE
	LD	(HL),E
	INC	HL
	LD	(HL),D
;
	POP	BC		;C=USER/DRIVE
	JR	CCP4
; -------------------------------
*EJEC
; -------------------------------
;;Eintritt von BIOS nach Warmstart, Teilinitialisierung des CCP-RAM
; Loeschen des Kommandopuffers
; Uebergabeparameter in Register C:Bit 7,6,5,4=USER  Bit 3,2,1,0=DRIVE
CCPW:	LD	A,(CSLOT)	;CCP interne SLOT-Belegung
	OUT	(PPIA),A
; Teilinitialisierung RAM
	PUSH	BC
	CALL	CCOPY
	POP	BC
; BDOS-Sprung regenerieren
	LD	HL,(CBDOS)
	LD	(BDOSAD),HL
; Kommandopuffer loeschen
CCP3:	XOR	A
	LD	(COMBL2),A
;;CCP Original Eintritt
CCP4:	LD	SP,CST2
	LD	A,(CSLOT)
	OUT	(PPIA),A
;
	LD	A,C		;neue Default-Disk
	AND	0FH		;User loeschen
	LD	(DEFDV),A	;merken neue Default-Disk
	LD	A,C
	RRA
	RRA
	RRA
	RRA
	AND	0FH
	LD	(DEFUS),A	;Default User merken
	CALL	SETUS		;Set User Code fuer $$$.SUB
	LD	C,0DH		;Reset Disk System
	CALL	BDOSJP
	LD	A,H		;BDOS gibt in H $$$.SUB-LW
	LD	(SYSDVC),A	;merken
	INC	A		;>0 machen
	INC	L		;war $$$.SUB-Datei?
	JR	Z,SETSUB	;ja
	XOR	A		;sonst =0
SETSUB:	LD	(DCF70),A	;auf LW +1 bei $$$.SUB vorh.
	LD	DE,COMBL2	;aktuelle Kommandolaenge
	CALL	CK12		;RET (PATCH fuer LAN)
	LD	A,(COMBL2)	;Kommando schon da?
	OR	A
	JR	NZ,ICBB8	;ja
; -------------------------------
*EJEC
;
;; CCP-Kommando holen
;  ==================
;
ICBA2:	LD	SP,CST2
	CALL	CCPDEF		;einstellen drive, user, dma
; Zeilenschaltung
	CALL	NEWLN		;CR,LF
; Laufwerk anzeigen
	LD	A,(SELDAK)	;aktuell selektiertes LW
	ADD	A,'A'
	CALL	PUTCH		;Ausgeben
; USER anzeigen
	LD	A,(SELUAK)	;aktuell selektierter user
	OR	A		;=0?
	JR	Z,USER0		;ja, User nicht in Prompt-Meldung
	CALL	BCDKON		;User BCD aufbereiten
	OR	A		;Zehner vom User vorhanden?
	JR	Z,USER09	;nein
	ADD	A,'0'
	CALL	PUTCH
USER09:	LD	A,C
	ADD	A,'0'
	CALL	PUTCH
; PROMPT anzeigen
USER0:	LD	A,'>'		;Prompt
	CALL	PUTCH
; Kommando von $$$.SUB oder Tastatur in Kommandopuffer eingeben
	CALL	IC92D		;holen naechstes Komm.
; Kommandopuffer auswerten (Beginn)
ICBB8:	LD	HL,COMBT2	;Entschl.zeiger auf Anfang
	LD	(COMPP2),HL
	CALL	CCPDEF		;einstellen default-Werte
; 1.Parameter (Kommandoname) in FCB eintragen
	CALL	FNHOL		;ersten Param. holen
	JP	NZ,ICF1B	;wenn */?, so Fehler
	LD	HL,(COMPP2)	;Entschl.zeiger in Komm.puffer
				;  (COMPP2) anfangs  = COMBT2
; wenn Laufwerk angegeben von Diskette laden
	LD	(PARBEG),HL	;fuer moeglichen Param.beginn
	LD	A,(DCF6E)	;expl. LW?
	OR	A
	JR	NZ,TKOM		;ja, kein residentes Komm.
; wenn Kommandoname zu lang von Diskette laden
	COND	LRESC<8
	LD	A,(CFCBF+LRESC)	;Filename < LRESC+1 Zeichen?
	CP	' '
	JR	NZ,TKOM		;nein, kein residentes Komm.
	ENDC
; Kommandoname in den Tabellen der residenten Kommandos suchen
	CALL	RSUCH		;residentes Kommando?
	JR	NZ,ICE86	;ja, ausfuehren
;
;;transientes Kommando von Diskette laden und starten
; ====================
TKOM:	LD	A,(CFCBF)
	CP	' '		;Filename da?
	JR	NZ,ICE7A	;ja
	LD	A,(DCF6E)	;expl. LW
	OR	A		;angegeben?
	JP	Z,ENDKB		;nein
;;wechseln aktuelles Laufwerk
	DEC	A
	LD	(DEFDV),A	;sonst neue Default-Disk
	JP	ENDKB		;Kommandoende
;
ICE7A:	CALL	LODCOM
	JR	COMLG0
; ===============================
; Kopieren der Programmteile ROM --> RAM
CCOPY:	LD	HL,CRAM0	;ROM
	LD	DE,CRAM2	;RAM
	LD	BC,LDIR0-CRAM0	;CCP RAM Laenge (Warmstart = Kaltstart)
	LDIR
	LD	HL,LDIR0	;ROM hinter STACK
	LD	DE,LDIR2	;RAM hinter STACK
	LD	BC,CCPE0-LDIR0	;Laenge
	LDIR
	RET
;
;;Residentes Kommando ausfuehren
; ==============================
; bei Aufruf:
; CY=1...Kommando im ROM, DE=Startadresse
; CY=0...Kommando im RAM, Verschieben und Starten auf 100H
;
ICE86:	JR	NC,URESI	;EXT-Kommando
;;echtes residentes Kommando im ROM ausfuehren
	LD	A,E		;Sonderfall
	OR	D
	JR	Z,COMLG0	;Startadresse =0 --> 'GO'-Kommando
;
	PUSH	DE		;Startadresse
	CALL	CCPDEF
	LD	HL,ENDKB	;Rueckkehradresse nach Kommandoausfuehrung
	EX	(SP),HL	 	;in Stack und Startadresse holen
	JP	(HL)		;und anspringen
; -------------------------------
;;mit EXT resident gemachtes Kommando verschieben und auf 100H starten
URESI:	LD	HL,(DCF98)	;vorhergehende Routinenadresse
	OR	A		;fuer Laengenberechnung
	SBC	HL,DE		;Differenz als Laenge
	JR	Z,COMLG0	;Laenge =0, kein LDIR!
	PUSH	HL
	LD	BC,TPA
	PUSH	BC
	ADD	HL,BC		;Ende nach LDIR
	LD	BC,(BDOSAD)
	OR	A
	SBC	HL,BC		;Ende nach Pseudo-BDOS?
	POP	HL
	POP	BC
	JR	C,LDLDIR	;nein
	CALL	NOSPC		;No Space
	JP	ENDKB		;Komm.ende
LDLDIR:	EX	DE,HL
	CALL	LDIRU		;File-laden simulieren (LDIR)
*EJEC
;
;; Kommando-Parameter aufbereiten (Programm steht auf 100H)
;  ========================================================
;
COMLG0:	CALL	FNHOL		;1. Filename nach Programmname
	LD	A,(DCF6E)	;expl. LW
	LD	(CFCBD),A
;
	LD	HL,CFCB0	;2. Filename nach Programmname
	CALL	IC9E0		;auf FCB + 10H
	LD	A,(DCF6E)	;expl. LW
	LD	(CFCB0),A
;
	XOR	A
	LD	(CFCBCR),A	;Record :=0
;
; Kommandopuffer --> DMA-Puffer
	LD	HL,(PARBEG)	;Stringlaenge (anfangs = 0)
				;  Zeiger Param.beg. in Komm.puff.
	LD	B,0		;Stringlaengenzaehler
	LD	DE,DEFDMA+1
;
ICEE7:	LD	A,(HL)		;Parameter hinterlegen
	LD	(DE),A
	OR	A
	JR	Z,ICEF1	 	;00-Byte (Stringende)
	INC	B		;Bytezaehler
	INC	HL		;Quelle (CCP-Kommandopuffer)
	INC	DE		;Ziel   (DMA-Puffer 80H)
	JR	ICEE7
;
ICEF1:	LD	A,B
	LD	(DEFDMA),A	;Stringlaenge hinterlegen
	LD	(COMPP2),HL	;Entschl.zeiger an Paramende
	CALL	NEWLN		;CR, LF
	CALL	CCPDEF		;einstellen default-Werte
;
	LD	SP,CST2	 	;CCP-STACK
;
	LD	HL,ANW
	LD	DE,COMBF2
	LD	BC,ANWE-ANW
	LDIR
;
	JP	CTPA		;Programm ausfuehren (CALL 100H im RAM)
; Rueckkehr erfolgt nicht ueber RET, sondern ueber RET2 im RAM direkt zu RETPA
; (erforderlich, weil XSUB Warmstart in RETURN umwandelt, aber Stack nicht regeneriert)
RETPA:	LD	SP,CST2	 	;CCP-STACK
	CALL	CCOPY		;RAM regenerieren
	CALL	TTEST		;Test, ob Treiber nachgeladen und resident machen
	CALL	CCPDEF
	JP	ICBA2		;naechstes Kommando
;
*EJEC
;;Ende der Kommandobehandlung
; ===========================
ENDKB:	LD	SP,CST2		; Ende der Kommando-Behandlung
	CALL	CCPDEF		; default-Werte wiederherst.
;
;; Test, ob Kommandorest leer
;  ==========================
 
	CALL	FNHOL		;holen naechsten Filenamen
	LD	A,(CFCBF)	;1. Zeichen Filename
	SUB	' '
	PUSH	HL
	LD	HL,DCF6E	; (DCF6E) = explizit gefordertes LW (anfangs = 0)
	OR	(HL)		;weder Filename noch expl. LW?
	POP	HL
	JP	Z,ICBA2		;ja, naechstes Kommando
 
; Parameterrest als Fehler protokollieren
 
ICF1B:	CALL	CCPDEF		;evtl fuer putch notw.
	CALL	NEWLN		;CR, LF
	LD	HL,(DCF71)	; anfangs = COMBT2
				;  Zeiger auf Parameterbeginn
ICF21:	LD	A,(HL)
	CP	' '		;Leerz.?
	JR	Z,ICF31		;ja, Param.ende
	OR	A		;Komm.ende?
	JR	Z,ICF31		;ja
	PUSH	HL
	CALL	PUTCH		;ungueltigen Rest protok.
	POP	HL
	INC	HL
	JR	ICF21
;
ICF31:	LD	A,'?'		;'?' als Fehlermeldung
	CALL	PUTCH
SUBMBR:	CALL	IC8AF		;$$$.SUB streichen
	JP	ICBA2		;naechstes Kommando
;
*EJEC
;
;;Test der Variablen BDOSAD, LADINI, TREND, EXTZ, CBDOS
; auf zulaessige Kombination, wenn OK Treiber fest in System einbinden
; -------------------------------
;BDOSAD:	Sprungbefehl auf Adresse 5
;LADINI:	Adresse, die im aktuellen Vorspann steht, auf (BDOSAD)+10H
;TREND:	CCP-intern: Treiberende, unterhalb dieser Adresse kann das erste
;		EXT-Kommando abgelegt werden
;EXTZ:	CCP-intern: EXT-Zeiger,  unterhalb dieser Adresse kann das naechste
;		EXT-Kommando abgelegt werden
;CBDOS:	CCP-intern: die Adresse, die auf CBDOS abgelegt ist, wird beim Warmstart
;		zur Regenerierung von BDOSAD benutzt
; -------------------------------
TTEST:	LD	HL,(EXTZ)
	LD	DE,(TREND)
	XOR	A
	SBC	HL,DE		;EXTZ-TREND
	RET	NZ		;EXT aktiv: Treiber laden verboten !!
; EXTZ=TREND --> kein EXT-Kommando nachgeladen
	LD	HL,(BDOSAD)
	LD	BC,LADINI
	PUSH	HL
	ADD	HL,BC
	CALL	CBCHL		;LADINI aus dem aktuellem Vorspann im RAM !! holen
	POP	HL
	XOR	A
	SBC	HL,BC		;BDOSAD-LADINI
	RET	NZ		;undefinierter Zustand von LADINI oder kein
				;gueltiger Vorspann vorhanden (tritt auf bei
				;zeitweise residenten Programmen z.B. DU, XSUB)
; EXTZ=TREND und BDOSAD=LADINI --> Originalzustand oder Treiber nachgeladen
	EX	DE,HL		;HL=TREND
	XOR	A
	SBC	HL,BC		;TREND-BDOSAD
	RET	C		;BDOSAD>TREND undefinierter Zustand
	RET	Z		;BDOSAD=LADINI=TREND=EXTZ Originalzustand
; EXTZ=TREND und BDOSAD=LADINI und BDOSAD<TREND --> Treiber nachgeladen
; Treiber resident machen, loeschen nur durch Kaltstart moeglich
	LD	HL,(BDOSAD)	;aktuelle BDOS-Adresse wurde vom Treiber veraendert
	LD	(CBDOS),HL	;Regenerierung von BDOSAD bei Warmstart
	LD	(TREND),HL	;Treiber
	LD	(EXTZ),HL	;1. Adresse fuer EXT-Kommandos
	RET
; -------------------------------
;
*EJEC
;
;; Bereitstellen naechstes Kommando
;  ================================
 
IC92D:	LD	A,(DCF70)	;$$$.SUB aktiv? (anfangs = 0)
				;wenn >0, so $$$.SUB-LW +1
	OR	A
	JR	Z,IC983		;nein, Kommando von Tastatur holen
; Kommando von Datei $$$.SUB holen
	CALL	IC8FB		;Tastendruck?
	JR	NZ,SUBMBR	;ja, $$$.SUB abbrechen
;
	LD	A,(DCF70)
	DEC	A
	CALL	IC8C3		;$$$.SUB-LW auswaehlen
;
BNK1:	LD	DE,SFD2	 	;FCB-Adresse
	CALL	IC8CF		;Open $$$.SUB
;
	JR	NZ,BNK2	 	;gefunden
	LD	A,(SELUAK)	;schon USER 0 probiert
	OR	A
	JR	Z,IC983		;ja, nicht da
;	
	XOR	A		;USER 0 auswaehlen
	CALL	SETUS
	JR	BNK1
;
BNK2:	LD	A,(SFRC2)	;Anzahl der Records im (letzten) Extent
	DEC	A		;-1
	LD	(SFCR2),A	;als aktuellen Record (falls Datei leer FF)
;
	LD	DE,COMBL2	;Record auf Eingabepuffer
	CALL	SETDMA		;Set DMA
;
	LD	DE,SFD2
	CALL	IC8F0		;read (leere Datei fuehrt zu read-Fehler)
	JR	NZ,IC983	;read-Fehler
;
	LD	HL,SFS22
	LD	(HL),0		;Schreibzugriff simulieren
;
	INC	HL
	DEC	(HL)		;Recordzahl im  Extent -1
;
	LD	DE,SFD2
	CALL	IC8D9		;Close
	JR	Z,IC983		;Fehler
;
	CALL	CCPDEF		;wiederherst. default-Werte
	JR	IC994
*EJEC
 
;; Holen naechstes Kommando von Konsole
;  ====================================
 
IC983:	CALL	IC8AF		;$$$.SUB streichen
	CALL	CCPDEF
 
; Im folgenden wird das BDOS erst dann durch "Lesen String" belegt, wenn
; das erste Zeichen des Kommandos anliegt. Dadurch kann das BDOS bis zur
; Kommandoeingabe von Hintergrund-Programmen benutzt werden.
;
; die Warteschleife wird durch den RAM gefuehrt, damit Eingriffe
; vom LAN moeglich werden
;
KOMMWZ:	CALL	KPRESS		;Taste gedrueckt?
	CALL	CK22		;RET (PATCH)
	JR	Z,KOMMWZ	;nein, BDOS nicht blockieren
	CALL	CCPDEF
;
	LD	DE,COMBF2
	LD	A,127		;max. Pufferlaenge
	LD	(DE),A
	LD	C,10		;holen String
	CALL	BDOSJP
;
IC994:	LD	HL,COMBL2
	LD	B,(HL)
	INC	B		;Stringlaenge
IC999:	INC	HL
	DJNZ	IC9A3		;Umwandlung in Grossbuchst.
	LD	(HL),B		;am Ende 00h
	RET
 
; falls SUBMIT-Strom laeuft, Kommando protokollieren
 
IC9A3:	LD	A,(DCF70)	;Submit aktiv?
	OR	A
	JR	Z,NSUBPR	;nein
;
	LD	A,(HL)
	PUSH	HL
	CALL	PUTCH
	POP	HL
NSUBPR:	LD	A,(HL)		;in Grossbuchstaben
	CALL	IC924		;umwandeln
	LD	(HL),A
	JR	IC999
; -------------------------------
*EJEC
;
;; CR,LF
;  =====
 
NEWLN:	LD	A,0DH
	CALL	PUTCH
	LD	A,0AH
 
;; Zeichen in A ausgeben
;  =====================
 
PUTCH:	PUSH	BC
	LD	E,A
	LD	C,02H
	CALL	BDOSJP
	POP	BC
	RET
 
 
;; Meldungen des CCP
;  =================
 
DCBDA:	DEFM	'Read Error'
	DFB	07H, 24H	; 24H = '$'
DCBE5:	DEFM	'No File$'
DCC93:	DEFM	'ALL (Y/N)?$'
DCD3B:	DEFM	'No Space'
	DFB	07H, 24H	; 24H = '$'
DCDAE:	DEFM	'File exists'
	DFB	07H, 24H	; 24H = '$'
BREAKT:	DEFM	'*break*'
	DFB	07H, 24H	; 24H = '$'
DCF48:	DEFM	'COM'
; -------------------------------
RDERR:	LD	BC,DCBDA	;Read Error
	JR	IC8AB
 
NOSPC:	LD	BC,DCD3B	;No Space
	JR	IC8AB
 
FILEX:	LD	BC,DCDAE	;File exists
	JR	IC8AB
 
IC8A8:	LD	BC,DCBE5	;No File
 
;; String ab (BC) ausgeben
;  =======================
 
IC8AB:	CALL	NEWLN		;CR,LF zuvor
IC8AD:	LD	A,(BC)
	CP	'$'
	JR	Z,IC88F
	CALL	PUTCH
	INC	BC
	JR	IC8AD
IC88F:	LD	A,' '		;ans Ende ein Leerzeichen
	JR	PUTCH
*EJEC
 
;; $$$.SUB streichen
;  =================
 
IC8AF:	LD	HL,DCF70	;$$$.SUB aktiv?
	LD	A,(HL)
	OR	A
	RET	Z		;nein
	LD	(HL),0		;sonst jetzt inaktiv
	DEC	A
	CALL	IC8C3		;Select Disk mit $$$.SUB
	LD	DE,SFD2		;Delete $$$.SUB
	JR	IC8E8
 
;; Einstellen default-Werte: drive, user, dma
;  ==========================================
;
CCPDEF:	CALL	CK32		;RET (PATCH-BDOS Zugriffe erlaubt)
	LD	A,(DEFUS)	;default user (anfangs = 0)
	PUSH	AF
	ADD	A,A
	ADD	A,A
	ADD	A,A
	ADD	A,A
	LD	HL,DEFDV	; default drive
	OR	(HL)		; user/default
	LD	(DEFAUL),A	;setzen default-Byte
	AND	0FH
	CALL	IC8C3		;default drive
	POP	AF		;default user
	CALL	SETUS
	LD	DE,DEFDMA	;default dma
 
;; Set DMA
;  =======
 
SETDMA:	LD	C,1AH
	JP	BDOSJP
 
;; Set User Code
;  =============
 
SETUS:	LD	(SELUAK),A	;merken ausgewaehlten User
	LD	E,A
	LD	C,20H
	JP	BDOSJP
 
;; Laufwerk fuer Dateiarbeit auswaehlen
;  ====================================
 
ICB26:	XOR	A
	LD	(CFCBD),A	;Standard-Laufwerk in FCB
	LD	A,(DCF6E)	;expl. LW?
	OR	A
	RET	Z		;ja, default annehmen
	DEC	A
 
; Select Disk (A)
 
IC8C3:	LD	(SELDAK),A	;merken aktuelle selekt. LW
	LD	E,A
	LD	C,0EH
	JP	BDOSJP
 
;; Open Standard-FCB
;  =================
 
IC8C8:	XOR	A
	LD	(CFCBCR),A	;Record :=0
	LD	DE,CFCBD
 
; Open
 
IC8CF:	LD	C,0FH
 
;; BDOS-Aufruf
;  ===========
 
BDOSRF:	CALL	BDOSJP
	INC	A		;RET Z bei A=FF
	RET
 
;; Close
;  =====
 
CLOSEF:	LD	DE,CFCBD
IC8D9:	LD	C,10H
	JR	BDOSRF
 
;; Search for first
;  ================
 
IC8DD:	LD	DE,CFCBD
	LD	C,11H
	JR	BDOSRF
 
;; Search for next
;  ===============
 
IC8E4:	LD	C,12H
	JR	BDOSRF
 
;; Delete File
;  ===========
 
DELETF:	LD	DE,CFCBD
IC8E8:	LD	C,13H
	JP	BDOSJP
 
;; Rename File
;  ===========
 
RENAMF:	LD	DE,CFCBD
	LD	C,17H
	JP	BDOSJP
 
;; Read sequentiell
;  ================
 
IC8ED:	LD	DE,CFCBD
IC8F0:	LD	C,14H
IC8F2:	CALL	BDOSJP		;BDOS-Ruf mit RAM-Einschaltung
	OR	A
	RET
 
;; Write sequentiell
;  =================
 
IC8F7:	LD	DE,CFCBD
	LD	C,15H
	JR	IC8F2
 
;; Tasten-Test (wenn Taste gedrueckt RET NZ)
;  =========================================
 
KPRESS:	LD	C,0BH
	CALL	BDOSJP
	OR	A
	RET
 
;; Tasten-Test (wenn ja '*break*' und RET NZ)
;  ==========================================
 
IC8FB:	CALL	KPRESS		;Taste?
	RET	Z		;nein
	LD	BC,BREAKT
	CALL	IC8AB
	XOR	A
	INC	A		;ret nz
	RET
*EJEC
 
;; Make File
;  =========
 
MAKEF:	CALL	DELETF
	LD	DE,CFCBD
	LD	C,16H
	JR	BDOSRF
 
;; Upper Case
;  ==========
 
IC924:	CP	'a'
	RET	C
	CP	'z'+1
	RET	NC
	AND	5FH
	RET
 
 
;; Suchen naechsten Parameterbeginn
;  ================================
 
NXTPAR:	LD	DE,(COMPP2)	;Entschl. Zeiger
	CALL	IC9D4		;naechstes Zeichen <> ' '
	LD	(DCF71),DE	;Parameterbeginn fuer Fehlermeldg
	LD	A,(DE)
	OR	A		;Zeichen da?
	RET			;RET Z: kein Parameter mehr da
 
 
;; Filenamen aufbereiten
;  =====================
; Uebertragung von 1 Dateibezeichnung aus Kommandopuffer ab akt. Position
; in FCB ab 5CH, dabei '*' in entsprechende Anzahl '?' umwandeln
; Kleinbuchstaben in Grossbuchstaben, Auffuellen mit Leerzeichen
; EX, S1, S2 mit 00 belegen
; Anzahl der '?' in A und B zurueckgeben / RET Z, wenn keine '?'
;
FNHOL:	LD	HL,CFCBD
; Auswerten Laufwerksangabe
IC9E0:	PUSH	HL
	CALL	NXTPAR		;uebergehen Leerzeichen
	JR	Z,IC9FE		;kein Parameter vorhanden
;
	SUB	40H
	JR	C,IC9FE		;keine Buchstabe
;
	LD	B,A		;expl. LW (+1)
	INC	DE
	LD	A,(DE)
	CP	':'		;LW-Bezeichner?
	JR	Z,ICA03		;ja, expl. LW im Filenamen
	DEC	DE
IC9FE:	XOR	A
	LD	(DCF6E),A	;Anzeigen kein expl. LW
	LD	A,(DEFDV)	;default-LW verwenden
	JR	ICA08
ICA03:	LD	A,B
	LD	(DCF6E),A	;expl. LW setzen
	INC	DE
ICA08:	LD	(HL),A		;LW in FCB setzen
	LD	B,8		;max. Laenge Filename
	CALL	ICA35
	LD	A,(DE)
	CP	'.'
	JR	NZ,ICA30
	INC	DE
	CALL	ICA35
ICA17:	XOR	A
	CALL	ICA51		;FCB-Rest mit 00 loeschen
	EX	DE,HL
	LD	(COMPP2),HL	;Entschl.zeiger weiter
	POP	HL
	LD	BC,11		;Kontrolle Filename
ICA23:	INC	HL
	LD	A,(HL)
	CP	'?'
	JR	NZ,ICA2A
	INC	B
ICA2A:	DEC	C
	JR	NZ,ICA23
	LD	A,B
	OR	A		;RET Z, wenn kein '*'/'?'
	RET
 
ICA30:	CALL	ICA4F
	JR	ICA17
 
ICA35:	CALL	IC9B6		;(DE) Parameter-Begrenzer?
	JR	Z,ICA4F		;ja
	INC	HL
	CP	'*'
	JR	NZ,ICA43
	LD	(HL),'?'
	JR	ICA45
 
ICA43:	LD	(HL),A
	INC	DE
ICA45:	DJNZ	ICA35
ICA47:	CALL	IC9B6
	JR	Z,ICA55
	INC	DE
	JR	ICA47
 
ICA4F:	LD	A,' '		;Rest mit Leerzeichen
ICA51:	INC	HL
	LD	(HL),A
	DJNZ	ICA51
ICA55:	LD	B,3		;fuer Typ oder FCB-Rest
	RET
*EJEC
 
 
;; Dez.zahl als Parameter konvertieren
;  ===================================
 
ICAE9:	CALL	NXTPAR		;suchen Parameteranfang
	JP	Z,ICF1B		;keiner mehr da, Parameterrest protokollieren
	LD	C,0
ICAF8:	CALL	IC9B6		;Begrenzer?
	JR	Z,ICB19		;ja
	INC	DE
	SUB	'0'
	CP	9+1		;'0'..'9'?
	JR	NC,ICB23	;nein
	LD	B,A
	LD	A,C		;bisheriger Wert
	CP	1+(256/10)	;zu gross?
	JR	NC,ICB23	;ja
	ADD	A,A
	ADD	A,A
	ADD	A,C
	ADD	A,A		;*10
	ADD	A,B		;+neue Ziffer
	LD	C,A
	JR	NC,ICAF8	;kein Ueberlauf
ICB23:	SCF
	RET
ICB19:	LD	(COMPP2),DE	;Param.ende merken
	LD	A,C
	OR	A
	RET
 
;; Test auf Begrenzer
;  ==================
 
IC9B6:	LD	A,(DE)
	PUSH	HL
	PUSH	BC
	LD	HL,DELIMT
	LD	BC,LDELMT
	CPIR			;Begrenzer?
	POP	BC
	POP	HL
	RET	Z		;ja
	CP	' '		;Steuerzeichen?
	JP	C,ICF1B		;ja, Parameterfehler
	RET
DELIMT:	DEFB	0
	DEFM	' =_.:;<>'
LDELMT	EQU	$-DELIMT
*EJEC
 
;; Suchen Zeichen <> ' '
;  =====================
 
IC9D4:	LD	A,(DE)
	OR	A
	RET	Z
	CP	' '
	RET	NZ
	INC	DE
	JR	IC9D4
 
 
;; Reg A in BCD-Form; Zehner nach A, Einer nach C
 
BCDKON:	LD	BC,0FF00H+10
BCDK10:	INC	B
	SUB	C
	JR	NC,BCDK10
 	ADD	A,C
	LD	C,A
	LD	A,B
	CP	9+1		;Zehner > 9?
	RET			;wenn ja, RET NC
*EJEC
;
;;residentes Kommando im ROM und im RAM suchen
; ============================================
;
; CY = 1,  Z = 0  Kommando im ROM gefunden
; RET  C, RET NZ  DE Startadresse im ROM
;
; CY = 0,  Z = 0  Kommando im RAM gefunden
; RET NC, RET NZ  DE Anfangsadresse, BC Endadresse der Kopie
;                 verschieben und starten auf 100H im RAM
; CY = 1,  Z = 1  Kommando nicht gefunden
; RET  C, RET  Z  DE Tabellenende
;=======================================================
RSUCH:	LD	HL,CFCBF	;Filename im FCB
	LD	DE,RESCI	;interne Kommandotabelle im ROM
	LD	B,LRESO	 	;Filenamenlaenge im ROM
	CALL	RSUP		;in ROM-Tabelle suchen
	RET	NZ		;CY=1 Z=0 intern gefunden --> DE=Startadr.
;
	LD	DE,RESC2	;externe Kommandotabelle im RAM
	LD	B,LRESC	 	;Filenamenlaenge im RAM
	CALL	RSUP		;in RAM-Tabelle suchen
	CCF			;CY=0 Z=0 extern gefunden --> auf 100H laden
	RET
; -------------------------------
*EJEC
;
; Unterprogramm: residentes Kommando in Tabelle suchen
; HL=Filename im FCB, DE=Tabellenanfangsadresse, B=Laenge der Kommandonamen
; CY=0, Z=1 nicht gefunden, CY=1, Z=0 gefunden
RSUP:	PUSH	HL
	PUSH	BC
RSUP1:	LD	A,(DE)		;naechstes Zeichen
	OR	A		;Tabellenende?
	JR	Z,RSUP4		;ja --> nicht gefunden
	CP	(HL)		;gleich?
	JR	NZ,RSUP3	;nein
	INC	DE		;sonst uebergehen
	INC	HL
	DJNZ	RSUP1		;naechstes Zeichen vergleichen
; -------------------------------
	EX	DE,HL		;gefunden
	LD	E,(HL)		;DE:=Kommandoadr.
	INC	HL
	LD	D,(HL)
;
	POP	BC
	INC	B
	INC	B
RSUP2:	DEC	HL		;Kommandolaenge und
	DJNZ	RSUP2		;2 Byte Adresse zurueckzaehlen
	DEC	B		;B=FF, Z=0
;
	LD	B,(HL)		;BC:=Kommandoadr. davor
	DEC	HL
	LD	C,(HL)
	LD	(DCF98),BC	;merken
	POP	HL
	SCF
	RET			;CY=1 Z=0
; -------------------------------
RSUP3:	INC	DE
	DJNZ	RSUP3
	INC	DE
	INC	DE
	POP	BC
	POP	HL
	JR	RSUP
; -------------------------------
RSUP4:	POP	BC
	POP	HL
	RET			;nicht gefunden
*EJEC
 
; File laden
; ==========
 
LODCOM:	LD	DE,CFCBT	;Typ
	LD	A,(DE)
	CP	' '		;explizit?
	JR	NZ,LODTDA	;ja
;
	LD	HL,DCF48	;sonst COM-Endung
	LD	DE,CFCBT	;Typ eintragen
	LD	BC,3
	LDIR
;
LODTDA:	LD	HL,0
	LD	(LFILE),HL	;Filelaenge:=0
;
	CALL	ICB26		;LW auswaehlen
;
LODFRN:	CALL	IC8C8		;Open
	JR	NZ,LODFFN	;gefunden
;
	LD	A,(SELUAK)	;schon User 0 probiert?
	OR	A
	JR	Z,LODNFU	;ja
;
	XOR	A
	CALL	SETUS		;set user 0
	JR	LODFRN
;
LODNFU:	LD	HL,SELDAK	; (SELDAK) anfangs = 0
	LD	A,(SYSDVC)	; anfangs  = 0
	CP	(HL)		;schon System-Diskette probiert?
	JP	Z,ICF1B		;ja, nicht da
;
	CALL	IC8C3		;sonst selektieren
	JR	LODFRN
;
LODFFN:	LD	DE,TPA
ICAA3:	PUSH	DE
	CALL	SETDMA		;Set DMA
	CALL	IC8ED		;Read
	POP	HL
	JR	NZ,ICAE2	;EOF oder Fehler
;
	LD	DE,0080H
	PUSH	HL
	LD	HL,(LFILE)	;Laenge +80h
	ADD	HL,DE
	LD	(LFILE),HL
	POP	HL
;
	ADD	HL,DE		;Ladeadr. weiter
;
	LD	BC,(EXTZ)	;Fuellungsstand EXT
	PUSH	HL
	LD	HL,(TREND)
	OR	A
	SBC	HL,BC
	POP	HL
;
	JR	Z,ICAC9		;nein
	DEC	B		;sonst Seite davor
ICAC9:	LD	D,H
	LD	E,L
	SBC	HL,BC		;noch Platz?
	JR	C,ICAA3		;ja
	CALL	NOSPC		;nein, No Space
	JP	ENDKB		;Kommandoende
;
ICAE2:	DEC	A		;EOF?
	CALL	NZ,RDERR	;nein, Read Error
	RET
;
*EJEC
; der folgende Speicherbereich wird fuer spezielle Dienstprogramme benoetigt
; z.B. zur Installation der residenten Treiber und zum Aufruf von Unterprogrammen im ROM
; -------------------------------
ANW:	JR	ANCA		;Unterprogrammruf DEFW, DEFB
	JR	ANRD		;Byte lesen B=Slot, HL=Adresse, A=Byte, DE bleibt
	JR	ANWR		;Byte schreiben (")
	DEFW	ANRD		;ROM-Marken
	DEFW	ANWR
	DEFW	JPHL2		;OUT (PPIA),A	JP (HL)
	DEFW	TASTMO		;Tastaturtreiber (physisch)
	DEFW	OUTASC		;Zeichen aus A zum Bildschirm (physisch)
	DEFW	CON		;Treiber CONSOLE
	DEFW	V24PL		;Treiber V24 PIO LIST
	DEFW	V24SC		;Treiber V24 SIO CONSOLE
	DEFW	V24RAM		;Tabellenanfangsadresse im RAM
	DEFW	RES		;CCP-Kommando RES
	DEFW	SLCTRL		;Adresse SLOT-Control-Byte
	DEFW	STTREI		;Treiberanzeige Statuszeile
	DEFW	CCP4		;CCP Eintritt
	DEFW	CK12		;PATCH-RAM je 3 Byte
	DEFW	XISMON		;Verbot Monitor
	DEFW	XNAMON		;Erlauben Monitor
	DEFW	FEMEIN		;Fehlermeldung in Systemzeile ein DE=Text
	DEFW	FEMAUS		;Fehlermeldung in Systemzeile aus
	DEFW	FZELLE		;Erzwingen Dauerfehleranzeige
	DEFW	V24FO		;V24 PIO-Format
	DEFW	DRUTYP		;V24 PIO-Drucker Typ
	DEFW	0
	DEFW	0
; -------------------------------
; Aufruf Unterprogramm in beliebigem SLOT (C000-FFFF RAM)
; alle Register werden uebergeben und zurueckgegeben, Aufrufbeispiel:
;	CALL	ANW
;	DEFW	UP-Adresse
;	DEFB	SLOT
; -------------------------------
ANCA:	EX	(SP),HL	 	;RET-Adr.+3
	INC	HL
	INC	HL
	INC	HL
	EX	(SP),HL
;
	LD	(ASTSV),SP
	LD	SP,ASTSV
;
	PUSH	HL
	LD	HL,ANCR2
	EX	(SP),HL	 	;Adresse zur Stackregenerierung in STACK (-2)
;
	PUSH	HL
	PUSH	AF
	IN	A,(PPIA)	;SLOT lesen
	LD	H,A
	POP	AF
	EX	(SP),HL	 	;SLOT in STACK (-4)
;
	PUSH	HL
	LD	HL,RTPA2
	EX	(SP),HL	 	;RTPA2-Adresse nach UP in STACK (-6)
;
	PUSH	HL		;(-8)
	PUSH	AF		;(-10)
	PUSH	DE		;(-12)
	LD	HL,(ASTSV)	;alten SP holen
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL		;HL = neue RET-Adresse
;
	DEC	HL		;davor steht im Programm die SLOT-Belegung
	LD	A,(HL)		;SLOT aus STACK holen
	DEC	HL
	LD	D,(HL)		;UP-Adresse aus STACK holen
	DEC	HL
	LD	E,(HL)
;
	EX	DE,HL		;HL=UP-Ansprungadresse
	POP	DE		;(-10)
	AND	00111111B
	OR	10000000B
	OUT	(PPIA),A
	POP	AF		;(-8)
	EX	(SP),HL	 	;UP-Ansprungadresse in STACK
				;HL regenerieren
	RET			;(-6) UP anspringen
				;Rueckkehr erfolgt auf Adresse RTPA2 (-4)
				;dort erfolgt SLOT regenerieren (-2)
; -------------------------------
ANRD:	PUSH	DE		;Byte von (HL) aus SLOT B in A lesen
	PUSH	BC
	LD	C,PPIA
	IN	E,(C)
	DI
	OUT	(C),B
	LD	A,(HL)
	JR	ANWR1
; -------------------------------
ANWR:	PUSH	DE		;Byte von A auf (HL) in SLOT B schreiben
	PUSH	BC
	LD	C,PPIA
	IN	E,(C)
	DI
	OUT	(C),B
	LD	(HL),A
ANWR1:	OUT	(C),E
	EI
	POP	BC
	POP	DE
	RET
; -------------------------------
TRABC:	PUSH	HL		;Treiberaufruf mit Parametern in A,B,C
	PUSH	AF		;STACK muss im Bereich C000-FFFF liegen !!
	IN	A,(PPIA)	;alte Slotbelegung lesen
	LD	H,A
	LD	A,(SLCTRL)
	OUT	(PPIA),A	;Standardbelegung ausgeben
	POP	AF
	EX	(SP),HL	 	;alte Slotbelegung in STACK, HL regenerieren
	CALL	TRBSCH		;Treiberadresse und SLOT ermitteln, umschalten, anspringen
	JP	RTPA2		;alte Slotbelegung aus STACK holen und ausgeben
; -------------------------------
ANWE:
;
*EJEC
;
; ===============================
;;Anfang der Programme, die im RAM laufen (Blocktransport)
; ========================================================
CBCHL:	IN	A,(PPIA)	;2 Byte von (HL) in BC vom RAM
	PUSH	AF
	LD	A,10101010B	;alles RAM
	JP	CBCHL2
;
LDIRU:	IN	A,(PPIA)	;LDIR
	PUSH	AF
	LD	A,10101010B	;alles RAM
	JP	LDIR2
;
LDDRU:	IN	A,(PPIA)	;LDDR
	PUSH	AF
	LD	A,10101010B	;alles RAM
	JP	LDDR2
; -------------------------------
; 5 Byte in RAM (3BH - 3FH) schreiben
CTPA:	LD	HL,3BH
	LD	(HL),0C3H	;3BH JP Befehl
	INC	HL
	LD	DE,TRABC-ANW+COMBF2	;E/A Treiberaufruf vom Anwenderprogramm
	LD	(HL),E		;3CH
	INC	HL
	LD	(HL),D		;3DH
	INC	HL
	LD	DE,COMBF2	;CCP-Kommandopuffer
	LD	(HL),E		;3EH
	INC	HL
	LD	(HL),D		;3FH
; -------------------------------
	LD	HL,RET2		;Rueckkehradresse
	PUSH	HL		;in STACK
	LD	A,10101010B	;alles RAM
	LD	HL,100H	 	;Startadresse (TPA)
	JP	JPHL2		;OUT (PPIA),A	JP (HL)
;
BDOSJP:	IN	A,(PPIA)	;BDOS-Ruf im RAM (CALL 5)
	PUSH	AF
	LD	A,10101010B
	JP	CBDR2
; ===============================
; ENDE SCPELO.S
; ===============================
