*H SCPELV.S
; AUTOR: Lutz Elssner
; STAND: 08.05.89
; ------------------
;;V24-Treiber fuer Drucker (PIO) und Plotter (SIO)
; ================================================
;
; Marke fuer Kaltstartinitialisierung SCP  : INIV24
; Marke fuer Kaltstartinitialisierung BASIC: INBV24
; Marken fuer Treibereingaenge: V24PL, V24SC, V24SR, V24SP, V24SL
;
; ===============================
	EXTERNAL PRTREI	 	;PRinter TREIber (PIO)
				;ohne Zeichbehandlung
				;bei Abbruch mit ^STOP ist CY=1
	EXTERNAL PRTOUT		;PRinter OUTput (PIO)
				;mit Zeichenbehandlung (Rand, TAB, ...)
				;bei Abbruch mit ^STOP ist CY=1
	EXTERNAL PRSTA		;PRinter STAtus (PIO) CTS-Bit Abfrage
				;NZ bereit / Z nicht bereit
				;bei Abbruch mit ^STOP ist CY=1
	EXTERNAL PULO		;DFEPU loeschen
	EXTERNAL FEMEIN	 FEMAUS	;Fehlermeldung in Systemzeile ein/aus
	EXTERNAL LORIPU	 RDRIPU	;Eingabepuffer loeschen / lesen
	EXTERNAL WATA		;warten auf Tastendruck
	EXTERNAL BIOSM0	 BIO10	;Fehleranzeige auf Kursorposition (BASIC)
	EXTERNAL BV24W1	 	;2.5 s warten, dann CR LF
; -------------------------------
DSTPTS	EQU	00B7H		;Direkter SToPTeSt
				;bei ^STOP ist CY=1
;
; Portadressen (Tabelle wird in RAM kopiert)
; ==========================================
;=== Laenge = 12 === im RAM von Hand aendern ! ===
V24TAB:	DEFB	50H		;CTC  fuer SIO Takt
	DEFB	69H		;SIOD Daten
	DEFB	6BH		;SIOC Control
;
; Standardwerte fuer Hardwareinitialisierung (Tabelle wird in RAM kopiert)
; ========================================================================
	DEFB	01000111B	;CTCC Steuerwort (DI, Zaehlermode, ...)
	DEFB	2		;CTCZ Zeitkonstante (9600 Baud)
	DEFB	11000001B	;WR3  SIO Empfaenger (8 Bit)
	DEFB	01000100B	;WR4  SIO (VT=16, 1 Stopbit, keine Paritaet)
	DEFB	01101010B	;WR5  SIO Sender (8 Bit)
	DEFB	0		;INZ  eingegebenes Zeichen
V24TE:
; ===============================
; V24 Tabelle IX-Adressierung (muss mit Reihenfolge der Tabelle uebereinstimmen)
CTC	EQU	0		;Portadressen
SIOD	EQU	1
SIOC	EQU	2
CTCC	EQU	3		;CTC-Init
CTCZ	EQU	4
WR3	EQU	5		;SIO-Init
WR4	EQU	6
WR5	EQU	7
INZ	EQU	8		;Zwischenspeicher eingegebenes Zeichen
; -------------------------------
*EJEC
;
; **************************************************************
;;V24 Druckertreiber (PIO)  [Aufruf Treiberroutine vom ROM-BIOS]
; ==============================================================
; V24 PIO LIST mit Zeichenbehandlung
V24PL:	LD	HL,PRTOUT	;Treiberadresse in HL
	JR	V24P
; ===============================
; V24 PIO PUNCH ohne Zeichenbehandlung
V24PP:	LD	HL,PRTREI	;Treiberadresse in HL
; ===============================
V24P:	INC	A
	JR	NZ,V24P1
; FF Initialisierung
;
V24P3:	OR	A
	RET
; -------------------------------
V24P1:	SUB	4
	JR	NZ,V24P2
; 03 Status Ausgabe
	CALL	PRSTA		;Routine aus ROM-BIOS (Ludewig)
	JR	C,V24PF		;Abbruch mit Taste
	LD	A,0FFH
	RET	NZ		;bereit
	XOR	A
	RET			;nicht bereit
; -------------------------------
V24P2:	INC	A
	JR	NZ,V24P3	;Ende
; 02 Zeichen Ausgabe
	LD	A,C
	CALL	VJPHL		;Routine aus ROM-BIOS (Ludewig) Adresse in HL
	RET	NC		;bei Abbruch mit ^STOP ist CY=1
V24PF:	JP	BRK0		;Anzeige BREAK BY ^STOP
				;in Systemzeile, danach ist CY=1
VJPHL:	JP	(HL)
; -------------------------------
*EJEC
; *********************************************************
;;V24 Treiber (SIO) Initialisierung  [Aufruf vom Kaltstart]
; =========================================================
; Initialisierung SCP
INIV24:	LD	A,0E1H		;Code fuer: POP HL
	LD	(XPRTO2),A
	LD	HL,XSV24
	JR	INIV
;
; Initialisierung BASIC
INBV24:	LD	HL,XBV24
INIV:	LD	BC,6
	LD	DE,XV24W
	LDIR
;
	LD	HL,V24TAB	;Tabelle in RAM transportieren
	LD	DE,V24RAM
	LD	BC,V24TE-V24TAB	;Laenge
	PUSH	DE
	LDIR
	POP	IX		;RAM Anfang
; automatische Erkennung, ob Hardware Vorteiler 13:1 vorhanden
	LD	A,(SLCTRL)
	AND	00010000B
	JR	Z,V24I		;8000H Slot 0,2
	LD	(IX+CTCZ),13	;8000H Slot 1,3
; Initialisierung CTC und SIO  IX=Tabellenadresse
V24I:	LD	C,(IX+CTC)	;Portadresse CTC
;
	LD	A,(IX+CTCC)	;Steuerwort
	OUT	(C),A
;
	LD	A,(IX+CTCZ)	;Zeitkonstante
	OUT	(C),A
;
	LD	C,(IX+SIOC)	;Portadresse SIO CONTROL
	LD	A,00011000B	;RESET PORT
	OUT	(C),A
;
	LD	B,4
	OUT	(C),B
	LD	A,(IX+WR4)	;WR4 (Stopbits, Parity)
	OUT	(C),A
;
	LD	B,3
	OUT	(C),B
	LD	A,(IX+WR3)	;WR3 (Empfaenger)
	OUT	(C),A
;
	LD	B,5
	OUT	(C),B
	LD	A,(IX+WR5)	;WR5 (Sender)
	OUT	(C),A
	RET
; -------------------------------
; Belegung der PATCH-Rufe fuer Fehler bei SCP und BASIC
XSV24:	JP	SV24W
	JP	SV24E
XBV24:	JP	BV24W
	JP	BV24E
; -------------------------------
*EJEC
; *******************************
;;V24 Treiber (SIO)
; ===============================
; V24 SIO CONSOLE
V24SC:
;
; V24 SIO READER
V24SR:
;
; V24 SIO PUNCH
V24SP:
;
; V24 SIO LIST
V24SL:	LD	IX,V24RAM	;Anfang der Tabelle im RAM
V24S:	INC	A
	JR	NZ,V24S1
; FF Initialisierung
	CALL	V24I
	RES	7,(IX+WR5)	;kein Zeichen im RAM
	RET
; -------------------------------
V24S1:	DEC	A
	JR	NZ,V24S2
; 00 Status Eingabe
	CALL	V2400		;Status
	LD	L,A		;L=Zeichen
	LD	A,0FFH
	RET	NC		;NC, A=FF bereit, L=Zeichen
	LD	A,L
	INC	A		;wird 00 bei RxD-BREAK
	OR	A
	RET	Z		;NC, A=00 nicht bereit bei RxD-BREAK
	SCF
	RET			; C, nicht bereit (PA, OV, FR, ^STOP)
; -------------------------------
V24S2:	DEC	A
	JR	NZ,V24S3
; 01 Zeichen Eingabe
	CALL	V2400		;Status
	LD	A,(IX+INZ)	;Zeichen
	RES	7,(IX+WR5)	;Zeichen abgeholt
	RET			;NC, A=Zeichen (OK)
				; C, (Fehler)
; -------------------------------
V24S3:	DEC	A
;
; 02 Zeichen Ausgabe
	JR	Z,V2402
; -------------------------------
	DEC	A
	JR	NZ,V24S5
; 03 Status Ausgabe
	CALL	V2403
	LD	A,0
	RET	C		;Abbruch mit Taste
	RET	Z		;A=0 nicht bereit
	DEC	A
	RET			;A=FF bereit
; -------------------------------
V24S5:	OR	A		;Ausgang bei falschen Codes in A
	RET			;NC, kein Fehler
; -------------------------------
*EJEC
;
; *******************************
;;V24 Unterprogramme
; ===============================
; Statusabfrage Eingabe
V2400:	LD	C,(IX+SIOC)	;SIO-CONTROL
	BIT	7,(IX+WR5)
	JR	NZ,DE006	;Zeichen im RAM
;
DE001:	CALL	BRKEY
	JR	C,DTR0		;Abbruch mit Taste A=0
;
	IN	A,(C)		;RR0
	BIT	0,A		;RECEIVER CHARACTER AVAILABLE
	JR	NZ,DE003	;Zeichen im SIO
;
	CALL	BREAK		;RxD-BREAK
	JR	NC,DE002	;OK
	DEC	A		;A=FF bei RxD-BREAK
DTR0:	PUSH	AF
	LD	A,5
	OUT	(C),A		;WR5
	LD	A,(IX+WR5)
	RES	7,A		;DTR=0
	OUT	(C),A
	POP	AF
	RET
;
DE002:	LD	A,5
	OUT	(C),A		;WR5
	LD	A,(IX+WR5)
	SET	7,A		;DTR=1
	OUT	(C),A
	JR	DE001		;wiederholen
;
DE003:	CALL	DTR0		;DTR=0
	JR	XE004		;Zeicheneingabe
;
DE006:	LD	A,(IX+INZ)	;Zeichen
	JR	XE006		;OK
;
XE004:	CALL	EFETA		;Empf. Fehler/Tastatur
	RET	C		;Fehler/Stop A=0
				;Z=1 OK   Z=0 fehlerhaftes Zeichen in A
	LD	C,(IX+SIOD)	;SIO DATEN
	SET	7,(IX+WR5)	;Zeichen im RAM
	JR	NZ,XE005	;bei Fehler schon in A
	IN	A,(C)		;Zeicheneingabe
XE005:	LD	(IX+INZ),A	;in RAM
XE006:	OR	A
	RET	NZ		;A<>0 bereit
	DEC	A		;A=FF bereit
	RET
; ===============================
*EJEC
;
; DTR AUSGABE
V2402:	LD	B,C		;Zeichen in B
DA021:	CALL	V2403		;Status
	RET	C		;Abbruch mit Taste
	JR	Z,DA021	 	;wiederholen
; -------------------------------
; 1 Zeichen senden aus B ohne Erlaubnisabfrage
; C=SIO-CONTROL, BCDEHL bleiben
XEA:	PUSH	DE
	LD	DE,0FFFFH	;TIME
DA023:	IN	A,(C)		;RR0
	BIT	2,A		;TRANSMIT BUFFER EMPTY
	JR	NZ,DA025	;OK
;
	DEC	DE		;Zeitschleife
	LD	A,E
	OR	D
	JR	NZ,DA023
;
	LD	DE,CLER	 	;'TxC-ERROR'
	CALL	PRCST
	POP	DE	
	SCF			;Fehler: Zeitueberschreitung Sender
	RET			;z.B. kein Sendetakt vom CTC
;
DA025:	POP	DE
	PUSH	BC
	LD	C,(IX+SIOD)	;SIO-DATEN
	OUT	(C),B		;Zeichenausgabe
	POP	BC
	OR	A
	RET
; ===============================
; DTR AUSGABE STATUS
V2403:	CALL	BRKEY
	RET	C		;Abbruch durch Taste
	LD	C,(IX+SIOC)
	LD	A,00010000B	;EXTERN RESET
	OUT	(C),A
	IN	A,(C)		;RR0
	AND	00100000B	;CTS
	RET 			;CY=0
; ===============================
*EJEC
; Abbruch durch Tastatur
BRKEY:	PUSH	BC
	PUSH	DE
	PUSH	HL
	PUSH	IX
	CALL	DSTPTS		;Direkter SToPTeSt
	POP	IX
	POP	HL
	POP	DE
	POP	BC
	JR	NC,BRK2	 	;nicht gedrueckt
	JR	NZ,BRK0		;^STOP gedrueckt
;
BRK2:	XOR	A		;nichts oder ^C gedrueckt
	DEC	A
	RET			;NC, NZ nicht gedrueckt
;
BRK0:	PUSH	DE
	LD	DE,BRTA	 	;'BREAK BY ^STOP'
BRK1:	CALL	PRCST		;Textausgabe
	POP	DE
	XOR	A
	SCF
	RET			; C, A=0 Abbruch durch Taste
; ===============================
; Abbruch durch RxD-BREAK (SIO Status)
; C=SIO-CONTROL  BCDEHL bleiben
BREAK:	IN	A,(C)		;RR0
	AND	10000000B	;BREAK / CY=0
	LD	A,00010000B	;EXTERN RESET
	OUT	(C),A
	RET	Z		;NC,  Z, OK
;
	PUSH	DE
	LD	DE,BRFE	 	;'RxD-BREAK'
	JR	BRK1		;Anzeige
; ===============================
; Empfaengerfehlerauswertung, Anzeige
; C=SIO-CONTROL
; CHL bleiben  A,B=fehlerhaftes Byte
EFETA:	LD	A,1
	OUT	(C),A
	IN	A,(C)		;RR1
	AND	01110000B
	RET	Z		;NC,  Z, OK
;
	BIT	4,A		;PARITY
	LD	HL,PAFE
	JR	NZ,EFE3
;
;
	BIT	5,A		;OVERFLOW
	LD	HL,OVFE
	JR	NZ,EFE3
;
	BIT	6,A		;FRAME
	LD	HL,FRFE
;
EFE3:	PUSH	BC
	LD	C,(IX+SIOD)	;SIO-DATEN
	IN	A,(C)		;fehlerhaftes Byte abholen
	POP	BC
	PUSH	AF
	LD	A,00110000B	;ERROR-RESET
	OUT	(C),A
;
	CALL	XV24E		;Fehleranzeige mit Eingabe (Meldung ab HL)
;
	POP	BC
	RET	C		;Abbruch durch ^C bei XV24E A=0
; other ignore
	XOR	A
	DEC	A		;Z=0
	LD	A,B		;fehlerhaftes Byte zurueckgeben
	RET			;NC, NZ, Zeichenfehler
; ===============================
; Ausgabe Fehlermeldung mit warten (DE)=Meldung
; BCHLIX bleiben
PRCST:	PUSH	BC
	PUSH	HL
	PUSH	IX
	EX	DE,HL
	CALL	XV24W
	POP	IX
	POP	HL
	POP	BC
	RET
; ===============================
*EJEC
; SCP Fehleranzeige mit warten
; HL:Fehlertext
SV24W:	CALL	PULO		;Fehlerpuffer loeschen
	LD	DE,DFEPU	;Fehlerpuffer
	PUSH	DE
	PUSH	HL
	LD	HL,V24TX	;V24 err
	CALL	VMOVE
	POP	HL		;spez. Fehler
	CALL	VMOVE
	POP	DE
	CALL	FEMEIN		;Fehlermeldung ein
	LD	A,7		;BEEP
	JP	OUTASC
; ===============================
; BASIC-Fehleranzeige mit warten
BV24W:	CALL	BV24UP		;Ausgabe mehrerer Teiltexte
	LD	A,7     	;BEEP
	CALL	OUTASC
	JP	BV24W1		;warten und CR LF
; ===============================
; SCP-Fehleranzeige mit Eingabe
; HL=Fehlertext (PARITY, OVERFLOW, FRAME)
; R:CY=1 ^C gedrueckt (abort) A=0
;   CY=0 (ignore)
SV24E:	CALL	PULO 		;Fehlerpuffer loeschen (HL bleibt)
SV24E1:	LD	A,(FZELLE)
	OR	A
	JR	NZ,SV24E1	;warten, bis Systemzeile frei
	CALL	XISMON		;Verbot Monitor (HL bleibt)
	LD	DE,DFEPU	;Fehlerpuffer
	PUSH	DE
	PUSH	HL
	LD	HL,V24TX	;V24 err
	CALL	VMOVE
	POP	HL
	CALL	VMOVE
	LD	HL,VTATX	;abort ignore
	CALL	VMOVE
	POP	DE
	CALL	FEMEIN		;Fehler anzeigen
	LD	A,7		;BEEP
	CALL	OUTASC
	CALL	WATA		;warten auf Taste
	PUSH	AF
	CALL	FEMAUS		;Fehleranzeige aus
	CALL	XNAMON		;erlauben Monitor
SV24E2:	POP	AF
	SUB	3
	SCF
	RET	Z		;^C CY=1 A=0
	CCF			;other CY=0
	RET
; ===============================
; BASIC-Fehleranzeige mit Eingabe
BV24E:	CALL	BV24UP
	LD	HL,VTATX	;abort ignore
	CALL	BIO10
	LD	A,7		;BEEP
	CALL	OUTASC
	CALL	LORIPU
	CALL	RDRIPU		;Eingabe
	PUSH	AF
	LD	HL,VCRLF	;CR LF
	CALL	BIO10
	JR	SV24E2
; ===============================
; UP fuer Fehleranzeige
BV24UP:	PUSH	HL
	LD	HL,VCRLF
	CALL	BIOSM0
	LD	HL,V24TX	;V24 err
	CALL	BIO10
	POP	HL		;spez. Text
	JP	BIO10
; -------------------------------
VMOVE:	LD	A,(HL)
	OR	A
	RET	Z
	LD	(DE),A
	INC	HL
	INC	DE
	JR	VMOVE
; ===============================
; Fehlertexte
VCRLF:	DEFW	0A0DH
	DEFB	0
;
CLER:	DEFM	'TxC-ERROR'
	DEFB	0
;
BRTA:	DEFM	'BREAK BY ^STOP'
	DEFB	0
;
BRFE:	DEFM	'RxD-BREAK'
	DEFB	0
;
PAFE:	DEFM	'PARITY'
	DEFB	0
OVFE:	DEFM	'OVERFLOW'
	DEFB	0
FRFE:	DEFM	'FRAME'
	DEFB	0
;
V24TX:	DEFM	'V24 err: '
	DEFB	0
;
VTATX:	DEFM	' (^c=abort, other=ignore)'
	DEFB	0
; *******************************
; ENDE SCPELV.S
; *******************************
