;*****************************************************
;
;BIC A 5105  SCP: BIOS-PROM-Teil
;Stand: 04.05.89 / Ludewig
;File: SCPLUD.S
;
;*****************************************************
;externals aus BICDITR.S
 external HOME	SELDSK	SETTRK	SETSEC	BSETDMA
 external READ	WRITE	SECTRAN	MRECOA	MRECOL
 external DIORTY
;
 external RDRIPU LORIPU	INKEY	OUTASC
;
 external CONST	CONIN	CONOUT	LIST	PUNCH	READER
 external LISTST CONOST	AUXIST	AUXOST	WBOOT	DEVTBL
;
 global	 INIBIOS STINI	SFLINI	STNEU	PULO	WATA
;
;*****************************************************
;BIOS-Sprungleiste (ROM) --> RAM
;-----------------------------------------------------
;
BIOPSL	JP	KCIBOOT		;0
	JP	KWBOOT
	JP	KCONST		;2
	JP	KCONIN
	JP	KCONOUT   	;4
	JP	KLIST
	JP	KPUNCH		;6
	JP	KREADER
	JP	KHOME        	;8
	JP	KSELDSK
	JP	KSETTRK	 	;10
	JP	KSETSEC
	JP	KSETDMA	 	;12
	JP	KREAD
	JP	KWRITE		;14
	JP	KLISTST
	JP	KSECTRAN   	;16
	JP	KCONOST
	JP	KAUXIST        	;18
	JP	KAUXOST
	JP	KDEVTBL		;20
;
;*****************************************************
;Koepfe der BIOS-Rufe (ROM) --> RAM
;-----------------------------------------------------
;
BIOPRA	LD	HL,CIBOOT	;0
	JR	BIOPA	;BIOPA muss im PROM folgen wie
			; BIORA im RAM !!
	LD	HL,WBOOT
	JR	BIOPA
	LD	HL,CONST	;2
	JR	BIOPA
	LD	HL,CONIN
	JR	BIOPA
	LD	HL,CONOUT  	;4
	JR	BIOPA
	LD	HL,LIST
	JR	BIOPA
	LD	HL,PUNCH	;6
	JR	BIOPA
	LD	HL,READER
	JR	BIOPA
	LD	HL,HOME	 	;8
	JR	BIOPA
	LD	HL,SELDSK
	JR	BIOPA
	LD	HL,SETTRK	;10
	JR	BIOPA
	LD	HL,SETSEC
	JR	BIOPA
	LD	HL,BSETDMA	;12
	JR	BIOPA
	LD	HL,READ
	JR	BIOPA
	LD	HL,WRITE	;14
	JR	BIOPA
	LD	HL,LISTST
	JR	BIOPA
	LD	HL,SECTRAN	;16
	JR	BIOPA
	LD	HL,CONOST
	JR	BIOPA
	LD	HL,AUXIST	;18
	JR	BIOPA
	LD	HL,AUXOST
	JR	BIOPA
	LD	HL,DEVTBL	;20
	JR	BIOPA
;
;*****************************************************
;BIOS-Rahmen (ROM) --> RAM
;-----------------------------------------------------
;
;=== Laenge = 33 === im RAM von Hand aendern ! ===
BIOPA	NOP
	NOP			;PATCH fuer LAN
	NOP
	LD	(BIORST),SP	;SP merken
	LD	SP,BIORST	;neuer Stack
	IN	A,(PPIA)
	PUSH	AF		;Slotkonfiguration merken
	LD	A,(SLCTRL)
	OUT	(PPIA),A	;Speicher umschalten
;
	CALL	JPHLR		;BIOS-Aufruf (kann Speicher umschalten!)
;
	POP	BC		;A,DE,HL NICHT BUNUTZEN !
	LD	C,PPIA
	OUT	(C),B		;Speicher rueckschalten
	LD	B,0		;fuer erw. Tastaturschnittstelle
	LD	SP,(BIORST)	;SP zurueck
	RET
;-----------------------------------------------------
JPHLP:	JP	(HL)
;
;*****************************************************
;Umspeichern zentrale BIOS-Teile in RAM
;-----------------------------------------------------
;
INIBIOS:LD	HL,BIOPSL	;BIOS-Sprungleiste
	LD	DE,BIORSL
	LD	BC,63
 	LDIR
	LD	HL,BIOPRA	;BIOS-Rahmen
	LD	DE,BIORRA
	LD	BC,JPHLP+1-BIOPRA
	LDIR
	LD	HL,SRST38	;PATCH fuer RST 38H
	LD	DE,XRST38
	LD	BC,5
	LDIR
	RET
;
SRST38	LD	A,0AAH		;alles RAM
	OUT	(PPIA),A
	RST	38H		;STOP-Zustand
;*****************************************************
;BIOS-Ruf 0: Kaltstart
;-----------------------------------------------------
CIBOOT:	RST	0	;Adr 0 im PROM Slot 0 !
;
;*****************************************************
;Aktualisieren IO-Byte, LW und User in Statuszeile
;-----------------------------------------------------
STNEU	IN	A,(PPIA)
	PUSH	AF
	AND	0FCH
	OR	2		;Page 0 auf Slot 2
	OUT	(PPIA),A
;--------------------------------
	LD	HL,IORET
	LD	A,(3)
	CP	(HL)		;IO-Byte veraendert?
	JR	Z,STN10	 	; Nein-->
;	-------------------------
	LD	(HL),A
	LD	DE,STIO
	CALL	MRECOA
	LD	A,0FFH
	LD	(STFLAG),A	;Anzeige anmelden
;--------------------------------
STN10	LD	HL,LWRET
	LD	A,(4)
	CP	(HL)		;LW, User veraendert?
	JR	Z,STN20	 	; Nein-->
;	-------------------------
	LD	(HL),A
	LD	B,A
	AND	0FH
	ADD	A,'A'
	LD	DE,STALW
	LD	(DE),A
	LD	A,B
	INC	DE
	CALL	MRECOL
	LD	A,0FFH
	LD	(STFLAG),A	;Anzeige anmelden
;--------------------------------
STN20	POP	AF
	OUT	(PPIA),A
	RET
;
;*****************************************************
;Statuszeile initialisieren (Aufruf vor SFLINI!)
;-----------------------------------------------------
STINI	LD	BC,CBSTEN-CBSTAT ;Anfangsbelg.Statuszeile
	LD	DE,STZEIL
	LD 	HL,CBSTAT
	LDIR
	XOR	A
	LD	(IORET),A	;Kopien loeschen
	LD	(LWRET),A
	DEC	A
	LD	(STFLAG),A	;Anzeige anmelden
	LD	(FUFLAG),A
	RET
;
CBSTAT	DEFM	'A0 \ A---- 95                           '
	DEFM	'                                        '
CBSTEN	
;
;******************************************************
;Floppy-Init fuer SCP (Aufruf nach STINI !)
;-----------------------------------------------------
SFLINI	CALL	XSFLIN
;	-------------------------	
	LD	A,(DPBB+DPBDNR)	;phys. LW 1 da?
	CP	1
	JR	NZ,SFLI10	; Nein-->
;
	LD	A,'B'		;LW in Statuszeile
	LD	(STLW+1),A
	LD	HL,STFLAG
	LD	(HL),0FFH	; Ausgabe anmelden
;	-------------------------
SFLI10	LD	HL,(DPHATB+4)	;phys. LW 2 da?
	LD	A,H
	OR	L
	JR	Z,SFLI20	; Nein-->
;
	LD	A,'C'		;LW in Statuszeile
	LD	(STLW+2),A
	LD	HL,STFLAG
	LD	(HL),0FFH	; Ausgabe anmelden
;	-------------------------	
SFLI20	LD	HL,SXDER1+2
	LD	DE,XDER1+2
	LD	BC,SXDER1+3-SXSELE	;PATCH-Rufe init
	LDDR
;	-------------------------
	RET
;----------------------------------------------
;Patch-Rufe
;
SXSELE	JP	SSELE	;Anzeige Disk-Format
SXLPLW	JP	SLPLW	;Diskwechsel im DSE-LW
SXDER1	JP	SDER1	;BIOS-Error u WH bei Not Ready
;
;******************************************************
;Patch-Ruf fuer Anzeige Diskformat
;-----------------------------------------------------
SSELE	LD	HL,STDSKF
	LD	DE,DISKA5
	LD	A,(DE)
	SUB	'A'
;
SSEL10	AND	A
	JR	Z,SSEL20
	LD	BC,8
	ADD	HL,BC		;Adressrechnung
	DEC	A
	JR	SSEL10
;
SSEL20	EX	DE,HL
	LD	BC,6
	LDIR			;Statuszeile laden
	LD	HL,STFLAG
	LD	(HL),0FFH	;Ausgabe anmelden
	RET
;
;******************************************************
;PATCH-Ruf Diskwechsel im DSE-LW
;-----------------------------------------------------
SLPLW	CALL	PULO
	INC	HL
	INC	HL		;HL=LPCHNG+2
	LD	BC,38
	CALL	FEANZ0		;Fehleranzeige
;
SLPLW2	CALL	WATA		;Warten auf Tastendruck
	CP	'*'
	JR	NZ,SLPLW2	;Warten auf '*'
;
	LD	A,(LPTAB)
	ADD	A,'A'
	LD	(STLW),A	;LW-Anzeige in Statuszeile
SLPLW3	CALL	FEMAUS		;Fehleranzeige aus
	JP	XNAMON		;STOP-Zustand erlauben
;
;******************************************************
;PATCH-Ruf fuer BIOS-Error u WH bei Not Ready
;-----------------------------------------------------
SDER1	CALL	PULO		;Puffer loeschen
	INC	HL
	INC	HL		;HL=DERRMS+2
	LD	BC,39
	LD	A,(FL14)
	CP	'R'		;Fehler: Not Ready?
	JP	NZ,FEANZ	; Nein-->Fehleranzeige, RET
;-----------------------------------------------------
SDER11	PUSH	HL
	LD	DE,DFEPU+41-1
	LD	HL,FZK
	LD	BC,FZKE-FZK
	LDIR			;Zusatztext laden
	POP	HL
;
	LD	BC,39
	CALL	FEANZ0		;Fehleranzeige
;
	CALL	WATA		;Warten auf Tastendruck
	AND	5FH		;Grossbuchstaben
	CP	'W'
	JR	NZ,SLPLW3	;sonst --> Weiter
;
	POP	HL		;Stackmanipulation !!
	CALL	SLPLW3		;Anzeige loeschen
	JP	DIORTY		;W --> Wiederholung Sektor
;-----------------------------------------------------
FZK	DEFM	'(W-Wiederholen / sonst-Weiter)'
FZKE	EQU	$
;
;*****************************************************
;UP fuer Puffer loeschen
;-----------------------------------------------------
PULO	PUSH	HL
	LD	HL,DFEPU
	LD	(HL),' '
	LD	D,H
	LD	E,L
	INC	DE
	LD	BC,80-1
	LDIR			;Puffer loeschen
	POP	HL
	RET
;
;*****************************************************
;UP fuer Warten auf Tastendruck
;-----------------------------------------------------
WATA	CALL	LORIPU
WATA2	LD	A,0FFH		;Daueranzeige erzwingen
	LD	(FZELLE),A
	CALL	INKEY		; (kein BIOS-Ruf!)
	JR	Z,WATA2
	JP	RDRIPU		;Zeichen lesen (kein BIOS-Ruf !)
;
;*****************************************************
;UP fuer Fehleranzeige in Statuszeile
;-----------------------------------------------------
;I: HL= Adr. ZK mit Fehlertext
;   BC= Laenge Fehlertext
;
FEANZ0	LD	A,(FZELLE)
	AND	A
	JR	NZ,FEANZ0	;Warten bis Statuszeile frei
	CALL	XISMON		;STOP-Zustand verbieten
FEANZ	LD	DE,DFEPU
	PUSH	DE
	LDIR			;Fehlertext umspeichern
;
	POP	DE
	CALL	FEMEIN		;Fehleranzeige
	LD	A,7		;BEEP
	JP	OUTASC		; (kein BIOS-Ruf !)
;
;******************************************************
