*H SCPLUE.S
;*************************************************************************
;Tastaturtreiber fuer SCP 5105
;Stand: 08.05.89
;Bearbeiter: Luetzner
;File: SCPLUE.S
;*************************************************************************
;
	external	IRSYS SYS06 SYS19 FTB FTB6 SOTB SOTB10
	external	STB STB2 CAPSB STOPB CTRIPU
	external	HOMEB KEYOFF RIPUZI LORIPU INKEY RDRIPU
	external	RDRIP1 ZEISA0 GETA35 YSLDIF
;=============================================================
monrq	EQU	4	;Bit 4,(SYNFLG)
monact	EQU	5	;    5
;=============================================================
YRZ240	defb	1
YZELLE	defb	0
YYNSEM	defb	0
YYNFLG	defb	0
Y2PPIA	defb	0
;
YTATUP	defw	STATUS	;enthaelt Adr. fuer UP,
;			 welches aktuelle F-Tastenzeile erzeugt
YTFLAG	defb	0FFh 	;Statuszeile anfordern
YUFLAF	defb	0FFh 	;Funktionstastenanzeige anfordern
YYNS2	DEFB	0
;=============================================================
;Anfang Stop-Monitor
;
;=== Laenge = 07 === im RAM von Hand aendern ! ===
YIOSMO	push	hl
	ld	hl,DECHL
	ld	(hl),35h	;NOP -> dec (hl)
	DEFB	21H		;LD HL,...
;=== Laenge = 04 === im RAM von Hand aendern ! ===
YPCRET	DEFW	0		;Adr., wo System-IR eingeschoben wurde
	ex	(sp),hl
	di
;
;Eintritt nach RST 38h
;
;=== Laenge = 41 === im RAM von Hand aendern ! ===
YONCAL	ld	(IRSPL3),sp
	ld	sp,IRSPL3
	push	af
;
	ld	a,20h		;monrq=0 / monact=1
	ld	(SYNFLG),a
;
	in	a,(PPIA)
	ld	(H2PPIA),a
	ld	a,(SLCTRL)
	out	(PPIA),a
	push	hl
	call	LORIPU
	pop	hl
	pop	af
;
	call	BIOSMC 	 	;EI in BIOSMC
;
	push	hl
	push	af
	ld	hl,SYNFLG
	di
	res	monact,(hl) 	;Stop-Monitor inaktiv
	dec	hl		;SYNSEM
;=== Laenge = 22 === im RAM von Hand aendern ! ===
YDECHL	nop			;dec (hl), wenn von BIOSMO kommend, sonst NOP
				;Flags bei dec (hl) !!
	ld	hl,DECHL
	ld	(hl),0		;dec (hl) -> NOP
	call	LORIPU 	 	;Tastaturpuffer loeschen
	ld	a,(H2PPIA)
	out	(PPIA),a
	pop	af
	pop	hl
	ld	sp,(IRSPL3)
	ei
	ret
;
;=== Laenge = 24 === im RAM von Hand aendern ! ===
YSTOP4	ld	a,(H1PPIA) 	;Slotbelegg. vor Syst.-IR
	out	(PPIA),a
	ld	e,(hl)
	inc	hl
	ld	d,(hl)		;DE= PC vor Syst.-IR
	ld	(PCRET),de	;nach Bios-Monitor dort weiter
	ld	de,BIOSMO
	ld	(hl),d
	dec	hl
	ld	(hl),e		;nach RETI  -> Bios-Monitor einschieben
	ld	a,(SLCTRL)
	out	(PPIA),a
	ret			;CY=1
;----------------------------------------------------------
YISMO1	PUSH	HL		;Verbieten BIOS-Monitor
	LD	HL,SYNSEM
	INC	(HL)
	POP	HL
	RET
;
YNAMO1	PUSH	HL		;Erlauben BIOS-Monitor
	LD	HL,SYNSEM
	DEC	(HL)
	POP	HL
	RET
;========================================================================
;
;Patch-Rufe
;
HSTB	jp	XXSTB
	ret
	ret
;	-------------------------
HJPCDE	ld	hl,TABET2
	ret
	ret
;	-------------------------
HIRSY2	jp	XXIRS2
	ret
	ret
;	-------------------------
HIRSY4	pop	hl
	jp	SYS19
;	-------------------------
HFTB	pop	hl
	jp	FTB6
;	-------------------------
HSTOPB	jp	XXSTOP
;	-------------------------
HRDRP2	jp	XXRDPU
;	-------------------------
HRDRP4	jp	XXRDP4
;	-------------------------
HSOTB1	OR	A	;NC bewirkt jp SOTB10
	RET
;	-------------------------
HGETA5	jp	XXGETA
;	-------------------------
HSOTB2	jp	XXSOT2
;	-------------------------
DISMON	JP	DISMO1	;Verbieten BIOS-Monitor
;
ENAMON	JP	ENAMO1	;Erlauben BIOS-Monitor
;
;====================================================================
;Erweiterung der STOP-Tastenbehandlung fuer's SCP
;IN: CY -  STOP  A=4
;    NC - ^STOP  A=3
;
;OUT:  NC -> A in RINGPU
;-------------------------------------------------
XXSTOP	ret	nc
;	-------------------------
	ld	hl,SYNFLG
	bit	monact,(hl)
	jr	z,XXSTP4	;STOP-Monitor inaktiv
;	-------------------------
	add	a,0D7h		;STOP-Codierung: 0DBh
	ret			;NC
;--------------------------------
XXSTP4	set	monrq,(hl)	;Anforderung
	dec	hl		;SYNSEM
	inc	(hl)
	dec	(hl)		;Unterbrechung erlaubt ?
	ret	nz		; nein -> CY=1
;	-------------------------
	inc	(hl)		;erneuten Aufruf sperren !
	ld	hl,(IRSPL2)
	jp	XSTOP4		;RETI-Adr. :=BIOSMO
;				(PCRET) := PCalt
;================================================================
;Erweiterung Sondertastenbehandlung
;
XXSTB	ld	hl,STB2
	ex	(sp),hl
	ld	e,a
	ld	d,0
	ld	hl,STACO2-30h
	ret
;	-----------------------------
STACO2	defb	0	;shift
	defb	1BH	;ESC
	defb	0       ;CTRL
	defb	0	;CAPS
	defb	0	;ALT
	defb	0	;PF1
	defb	0
	defb	0
;
	defb	0
	defb	0	;PF5
	defb	0	;GRAPH
	defb	0
	defb	0	;STOP
	defb	0
	defb	0
	defb	0Dh	;enter
;
	defb	20h	;space
	defb	0	;home
	defb	16h	;ins   (^V)
	defb	7Fh	;del
	defb	8	;<-
	defb	5	;/\
	defb	18h	;\/
	defb	4	;->
;**************************************************************************
;ALT-Behandlung
;
ALTB	call	ZEISA0	;Umschalten ZS
	ret
;**************************************************************************
TABET2	defb	30h
	defw	SOTB
	defb	33h
	defw	STB
	defb	34h
	defw	CAPSB
	defb	35h
	defw	ALTB
	defb	3Ah
	defw	FTB
	defb	3Ch
	defw	STB	;Graph
	defb	3Dh
	defw	STOPB
	defb	41h
	defw	STB	;ENTER,SPACE
	defb	42h
	defw	HOMEB
	defb	0FFh
	defw	STB
;
;----------------------------------------------------------------
;Erweiterung (alphanumerische) Tastenbehandlung
;Wandlung 8-Bit-Codes in 7-Bit-ASCII
;
XXSOT2	ld	hl,TAB
	ld	bc,8
	cpir
	ret	nz
;	---------------------
	ld	c,7
	add	hl,bc
	ld	a,(hl)		;7-Bit-ASCII
	ret
;-----------------------------------------
TAB	defb	8Eh	;AE
	defb	99h	;OE
	defb	9Ah	;UE
	defb	84h	;ae
	defb	94h	;oe
	defb	81h	;ue
	defb	0E1h	;sz
	defb	5Ch	;\
;-----------------------
	defb	5Bh
	defb	5Ch
	defb	5Dh
	defb	7Bh
	defb	7Ch
	defb	7Dh
	defb	7Eh
	defb	40h
;======================================================================
;falls innerhalb RDRIPU Stop-Monitor war, an Anfang zurueck
XXRDP4	di
	pop	de
	call	GETA35		;NZ -> Zeichen in RINGPU
	jp	z,RDRIP1	;zurueck nach Anfang Read - Ringpuffer
;	---------------------
	push	de		;Fortsetzungsadr.
	ret			;in Read - Ringpuffer
;======================================================================
;fuer SCP RINGPU parallel mit Puffer in Statuszeile
;ab STTAST (39 Byte) bearbeiten
;
XXRDPU	push	bc		;c - Zeichen
	push	de
	ld	hl,(LESRIP)
	ld	de,STTAST	;Beginn Pufferbereich
	ld	b,39
XRDPU2	ld	a,(SCHRIP)
	cp	l		;Low (LESRIP)
	jr	z,XRDPU3	;weiter kein Zeichen
;	-----------------------
	ld	a,(hl)
	cp	7Fh 		;DEL u. STOP (0DBh), falls Monitor aktiv ist
	jr	c,XRDP22
;	-----------------------
	ld	a,'.'
;	-----------------------
XRDP22	ld	(de),a
	inc	de
	call	RIPUZI
	djnz	XRDPU2
;	------------------------
	jr	XRDPU6
;
XRDPU3	ld	a,20h
XRDPU4	ld	(de),a
	inc	de
	djnz	XRDPU4
;	-----------------------
XRDPU6	ld	hl,STFLAG
	ld	(hl),0FFh	;Statuszeile anfordern
	pop	de
	pop	bc
	ret
;===================================================================
;Erweiterung System-IR
;aller 240ms wird Statuszeile aktuallisiert, falls (FZELLE)=0
;		sonst steht Fehlermeldung in Statuszeile !
;-------------------------------------------------------------
XXIRS2	ld	hl,IRZ240
	dec	(hl)
	jr	nz,XXIR22	;Zeit noch nicht um
;	-----------------------
	ld	(hl),12
	inc	hl		;FZELLE
	ld	a,(hl)
	or	a		;Fehlermeldg. vorhanden ?
	jr	z,XXIR21	; nein
;	-----------------------
	dec	(hl)
	jr	nz,XXIR22	; ja -> bleibt stehen
;	-----------------------
	call	FEMAUS		;Fehlermeldung aus, FU- u. STFLAG:=0FFh
;------------------------------
XXIR21	ld	hl,(STATUP)
	call	CALLHL
;	-----------------------
XXIR22	pop	hl		;RET-Adr.
	jp	SYS06
;==============================================================
CALLHL	jp	(hl)
;==============================================================
;Falls monrq,(SYNFLG)=1 u. (SYNSEM)>0 -> STOP nachbilden
;
XXGETA	ld	a,(SYNFLG)
	bit	monrq,a
	ret	z	;keine unerfuellte STOP-Anforderung
;	---------------------------
	ld	hl,ASTAMT
	ld	a,14h	;CTRL- u. ALT-Bit ggf. ruecksetzen
	or	(hl)
	ld	(hl),a
	inc	hl	;Spalte von STOP-Taste
	set	4,(hl)	;evtl. CTRL ruecksetzen, STOP dominiert
	ld	(KCLK1T),a	;Keyklick off
	call	STOPB
	xor	a
	ld	(KCLK1T),a	;Keyklick on
	ret
;*************************************************************************
;Umladeprogramme zum initialisieren der RAM-Bereiche
;-------------------------------------------------------------------------
;PATCH-Rufe init.
;
INITST	di
	ld	hl,HSTB
	ld	de,XSTB
	ld	bc,XXSTOP-HSTB
	ldir
;-----------------------------------------------------
;Routinen fuer System-IR u. STOP-Monitor in Syst.-RAM
;sowie der RAM-Zellen u. YISMO1/YNAMO1
;
	ld	hl,YRZ240
	ld	de,IRZ240
	ld	bc,HSTB-YRZ240
	ldir
;-----------------------------------------------------
	ld	hl,HOMECO
	ld	(hl),10	 ;HOME=10 fuer SCP
;-----------------------------------------------------
	ld	a,(SLCTRL)
	ld	(RIRSYS+YSLDIF),a
;-----------------------------------------------------
	ret
;*************************************************************************
;TASTATURMODUL - Ansprung vom Treiberkopf im Syst.-RAM
;
;IN : A=0    Status fuer Eingabe
;     A=1    Zeichen-Eingabe
;    (A=2    Zeichen-Ausgabe         I ggf. fuer andere
;     A=3    Status fuer Ausgabe)    I Treiber !!!
;     A=0FFh Kaltstart
;
;-------------------------------------------------------------------------
TASTMO	cp	0FFh
	jr	z,TCOLD
;	---------------------------
	or	a
	jr	z,TCONST
;	---------------------------
	dec	a
	jr	z,TCONIN
;----------------------------------
	ret
;==================================
;Kaltstart des Tastaturtreiber's
;erfolgt einmalig im Anlauf
;
;================================================
;Warmstart des Tastaturtreiber's (fall's notwendig)
;
;OUT: Reg.: HL,DE,AF
;     evtl. EI
;--------------------------------
TCOLD	JP	LORIPU	;RINGPU u. Statuszeilen-Puffer loeschen
;
;=================================================
;Status fuer Tastatur
;
;OUT: Reg.: AF
;     EI
;
;---------------------------------
;
TCONST	call	INKEY	;NZ - Zeichen da
	ld	a,0
	ret	z
;	--------------------------
	dec	a
	ret		;A = 0FFh  - Zeichen da
;==================================================
;Conin fuer Tastatur
;
;OUT: A - Zeichen
;     EI
;---------------------------------
;
TCONIN	call	RDRIPU	;wartet auf Zeichen
	ret		;B wird auf 0 gesetzt
;*************************************************************************
