;*********************************************
; AUTOR: Michael Mueller  1EKE
; STAND: 04.05.89
; FILE: SCPMUE.S
;*********************************************
;
;	extrn IRSPL3, STZEIL, VFTINI, STATUP
;	extrn KEYOFF, TCONIN, LDIRU
;	extrn STFLAG, FUFLAG, FZELLE
;
 EXTERNAL PTVRA1 PTVRA2	FEMEIN	FEMAUS	KEYON	STNEU
 EXTERNAL BICOP
;
;OUTASC	EQU	0A2H
VFTINI	EQU	15CH
;
; Tasten und Zeichen
; ------------------
;
STOP	equ	0DBH
DOWN	equ	18H
UP	equ	05H
CR	equ	0DH
ESCC	equ	1BH
SPACE	equ	20H
SPX	equ	SPACE+80H
DELC	equ	7FH
;
;
; UP fuer Routineanzeige
; ----------------------
;
FUNKTA: ld	hl,FUFLAG	;Anzeige Funktionstasten
	ld	a,(hl)
	or	a
	ret	z
	ld	(hl),0
	jp	VFTINI
;
STATUS	CALL	STNEU		;IO-Byte, LW, User evtl. neu
	ld	hl,STFLAG	;Anzeige Statuszeile
	ld	a,(hl)
	or	a
	ret	z
	ld	(hl),0
	ld	DE,STZEIL	;SCP-Statuszeile
	jr	PUTMSG
;
MEMZ:	ld	HL,(MADR)	;16 Byte Speicher
	ld	a,CR
	call	CO
	call	DCM05		;ab (MADR)
PUTPUF:	ld	DE,PUFF		;Ausgabe des Puffers
;
PUTMSG:	push	DE		;Ausgabe in Zeile 25, 2*80 Zeichen
	call	PTVRA1		;Eing: DE Adr Puffer
	pop	DE
	call	PTVRA2
LEERZ:	ret
;
 GLOBAL	BIOSMC
BIOSMC:	call	RPUSH			;Eintritt BIOS-Monitor
	ld	HL,(STATUP)		;Retten Register
	ld	(STATU1),HL		;Retten STATUP
	ld	HL,LEERZ		;-> ret
	ld	(STATUP),HL
	call	KEYON			;Zeile 25 ein
	xor	a			;Fehlermeld. aus
	ld	(FZELLE),a
BIOSM1:	ld	DE,TXTPR		;Prompt
	call	STRNG
	call	CI
	jr	c,BIOSM2
	call	BIOSM3			;Verteiler
	jr	BIOSM1
BIOSM2:	ld	HL,(STATU1)
	ld	(STATUP),HL		;STATUP zurueck
	ld	DE,LEERZ
	and	A
	sbc	HL,DE			;falls LEERZ ->
	call	Z,KEYOFF		;Zeile 25 aus
	ld	a,0FFh			;Anzeige ein
	ld	(FUFLAG),a
	ld	(STFLAG),a
	call	RPOP			;Register zurueck
	ret
;
BIOSM3	LD	HL,SYNS2
	DEC	(HL)
	INC	(HL)
	RET	NZ			;BIOS-MONITOR gesperrt
	and	5Fh
	cp	'D'
	jr	z,DCMDO
	cp	'S'
	jr	z,SCMDO
	cp	'I'
	jp	z,ICMDO
	cp	'O'
	jp	z,OCMDO
	CP	'P'
	JP	Z,PCMDO
	cp	'R'
	jp	z,RCMDO
	cp	'X'
	jp	z,XCMDO
	cp	'F'
	jp	z,FCMDO
	cp	'Q'
	jp	z,QCMDO
	ret
;
; D-Kdo Speicher anzeigen
; -----------------------
;
DCMDO:	call	GETADC			;Eingabe Speicheradresse
	ret	c			;stop
DCMDO1:	call	DCM00			;Anzeige 16 Byte
DCMDO2:	call	CI
	ret	z			;stop/enter
	cp	DOWN
	jr	z,DCMDO1			;naechster Bereich
	cp	UP
	jr	nz,DCMDO2
	ld	DE,-20H			;vorheriger Bereich
	add	HL,DE
	jr	DCMDO1
;
; UP 16 Byte aus Speicher anzeigen
; --------------------------------
; (auch bei Routineanzeige gerufen!)
;
DCM00:	ld	A,'D'			;Kdo-Zeichen
	call	OPENK			;Eing HL Speicheradresse
DCM05:	call	PUTAD			;Speicheradresse anzeigen
	call	SPOUT
	ld	DE,DPUFF		;umladen 16 Byte in DPUFF
	ld	BC,16
	call	LDIRU			;(HL) Speicher
	ld	B,16
	ld	DE,DPUFF
DCM10:	ld	A,(DE)			;Anzeige als Byte
	inc	DE
	call	PUTBS
	djnz	DCM10
	ld	DE,DPUFF
	call	SPOUT
	ld	B,16
DCM20:	ld	A,(DE)			;Anzeige als Zeichen
	inc	DE
	cp	20H
	jr	c,DCM30
	cp	7EH
	jr	c,DCM40
DCM30:	ld	A,'.'			;kein Zeichen -> Punkt
DCM40:	call	CO
	djnz	DCM20
	call	SPOUT
	ret
;
; S-Kdo RAM anzeigen und aendern
; ------------------------------
;
SCMDO:	call	GETADC			;Eingabe Speicheradresse
	ret	c			;stop
SCM00:	ld	A,'S'			;Kdo-Zeichen
	call	OPENK
	call	PUTAD			;Speicheradresse anzeigen
	ld	B,8
SCM10:	call	SPOUT
	call	LDAHL			;Byte holen
	call	PUTBY			;Byte anzeigen
	ld	A,'-'
	call	CO
	ex	DE,HL
	call	GETAD			;Eingabe neues Byte
	ex	DE,HL
	ret	c			;stop
	jr	z,SCM20			;keine Eingabe
	ld	C,A			;Trennzeichen merken
	call	LDHLE			;Byte in RAM
	ld	A,C
SCM20:	inc	HL
	cp	CR
	ret	z			;war enter
	djnz	SCM10			; <8 mal
	jr	SCM00			;neue Zeile
;
LDAHL:	push	BC
	ld	DE,DPUFF
	ld	BC,1
	call	LDIRU
	dec	DE
	dec	HL
	ld	A,(DE)
	pop	BC
	ret
;
LDHLE:	push	BC
	ld	A,E
	ex	DE,HL
	ld	HL,DPUFF
	ld	(HL),A
	ld	BC,1
	call	LDIRU
	ex	DE,HL
	dec	HL
	pop	BC
	ret
;
; I-Kdo Eingabe von Port
; ----------------------
;
ICMDO:	call	GETADC			;Eingabe Portadresse
	ret	c			;stop
	ld	C,L
ICM00:	ld	A,'I'			;Kdo-Zeichen
	call	OPENK
	ld	A,C
	call	PUTBS			;Anzeige Portadresse
	ld	B,16
ICM10:	in	A,(C)			;Einlesen Port
	call	PUTBS			;Anzeige Daten
ICM20:	call	CI
	ret	c			;stop
	jr	nz,ICM20		;kein Trennzei
	cp	CR
	ret	z			;enter
	djnz	ICM10			;<16 mal
	jr	ICM00			;neue Zeile
;
; O-Kdo Ausgabe auf Port
; ----------------------
;
OCMDO:	call	GETADC			;Eingabe Portadresse
	ret	c
	ld	C,L
OCM00:	ld	A,'O'			;Kdo-Zeichen
	call	OPENK
	ld	A,C
	call	PUTBS			;Anzeige Portadresse
	ld	B,8
OCM10:	call	GETAD			;Eingabe Daten
	ret	c
	jr	z,OCM20			;keine Eingabe
	out	(C),L			;Ausgabe auf Port
OCM20:	cp	CR			;Ende ?
	ret	z			;ja
	call	SPOUT
	djnz	OCM10			;< 8 mal
	jr	OCM00			;sonst neue Zeile
;
; P-Kdo Bildschirmkopie
; ---------------------
;
PCMDO	CALL	CO			;Kdo-Zeichen anzeigen
PCMDO2	CALL	CI
	RET	C			;RET bei STOP
	CP	CR
	JR	NZ,PCMDO2
	JP	BICOP			;Bildkopie bei ENTER
;
; R-Kdo Registeranzeige
; ---------------------
;
RCMDO:	call	RCM10			;Anzeige 1. Registersatz
RCMDO1:	call	CI
	ret	z
	cp	UP
	jr	z,RCMDO
	cp	DOWN
	call	z,RCM20			;Anzeige 2. Registersatz
	jr	RCMDO1
;
RCM10:	ld	HL,A1RET+1		;1. Registersatz
	ld	DE,TXTRC1
	ld	A,'R'
	jr	RCM30
;
RCM20:	ld	HL,A2RET+1		;2. Registersatz
	ld	DE,TXTRC2
	ld	A,'r'
;
RCM30:	push	DE			;Kdo-Zeichen ausgeben
	call	OPENK
	pop	DE
	ld	B,10			;Anzahl
RCM40:	call	SPOUT
	ld	A,(DE)
	ld	C,A
	ld	A,':'
	call	STRCO			;Registername + ":"
	dec	HL
	ld	A,(HL)
	call	PUTBY			;Register anzeigen
	bit	7,C			;Doppelregister ?
	jr	nz,RCM50		;ja
	dec	HL
	ld	A,(HL)
	call	PUTBY
RCM50:	djnz	RCM40
	ret
;
; X-Kdo Register anzeigen und aendern
; -----------------------------------
;
XCMDO:	ld	DE,TXTRC1		;DE Text
	ld	HL,A1RET+1		;HL Rettungszellen
XCM10:	ld	A,(DE)
	or	A
	jr	nz,XCM20		;Ende der Tabelle ?
	ld	DE,TXTRC2		;Tabellenanfang
	ld	HL,A2RET+1
XCM20:	ld	A,'X'			;Kdo-Zeichen
	push	DE
	call	OPENK			;anzeigen
	pop	DE
	ld	B,1
	call	RCM40			;Reg anzeigen
	ld	A,'-'
	call	CO
	push	DE
	ex	DE,HL
	call	GETAD			;Eingabe
	ex	DE,HL
	jr	c,XCM30			;stop
	jr	z,XCM30			;keine Eingabe
	ld	(HL),E			;1.Byte
	bit	7,C
	jr	nz,XCM30		;Doppelregister ?
	inc	HL
	ld	(HL),D			;2.Byte
	dec	HL
XCM30:	pop	DE
	ret	c
	cp	CR			;enter ?
	jr	nz,XCM10		;nein, weiter
	ret
;
; F-Kdo Einstellen Funktionstasten
; --------------------------------
;
FCMDO:	call	CO			;Kdo-Zeichen
FCMDO1:	call	CI
	ret	c			;stop
	call	TEZIF			; "0"..."9"
	jr	c,FCMDO1
	call	CO2			;Echo
	ld	C,A
	ld	A,ESCC			;Folge "ESC,ESC,Nr,....,0"
	call	OUTASC
	call	OUTASC
	ld	A,C
	call	OUTASC
	ld	B,15			;15 Zeichen
FCMDO2:	call	CI
	cp	ESCC			;Abbruch
	jr	z,FCMDO3
	call	CO2
	call	OUTASC
	djnz	FCMDO2
FCMDO3:	xor	A			;NUL anhaengen
	call	OUTASC
	ret
;
; Q-Kdo Einstellen Anzeigemodus der 25. Zeile
; -------------------------------------------
;
QCMDO:	call	CO			;Kdo-Zeichen anzeigen
QCMDO1:	call	CI
	ret	z			;wenn stop, enter
	and	5Fh
	ld	HL,STATUS
	cp	'S'			;Anzeige SCP-Status
	jr	z,QCMDO3
	ld	HL,FUNKTA
	cp	'F'			;Anzeige Funtionstasten
	jr	z,QCMDO3
	ld	HL,LEERZ
	cp	'L'			;keine Anzeige
	jr	z,QCMDO3
	cp	'D'			;Anzeige Speicherbereich
	jr	nz,QCMDO1		;kein guelt Modus
	call	GETADC			;Eingabe Adr dazu
	ld	(MADR),HL
	ld	HL,MEMZ
	jr	QCMDO4
QCMDO3:	call	CO
	call	CI
QCMDO4:	ld	(STATU1),HL		;Ablegen UP-Adresse
	ret
;
;Eingabe Adresse von Tastatur
;----------------------------
;
GETADC:	call	CO			;mit Ausgabe Kdo-Zeichen
;
GETAD:	ld	HL,0
	call	CI			;keine Eingabe ?
	ret	z			;Z=1, falls stop -> CY=1
GETA1:	call	TEHEX			;Test auf Hex-Ziffer
	jr	c,GETA2			;nein
	call	CO			;Echo
	call	ASHEX			;Wandlung
	add	HL,HL
	add	HL,HL
	add	HL,HL
	add	HL,HL
	add	A,L
	ld	L,A
GETA2:	call	CI			;naechste Eingabe
	jr	nz,GETA1		;Trennzeichen ?
	ret	c			;wenn stop CY=1
	or	A
	ret				;sonst Z=0, CY=0
;
;Tastatureingabe mit Setzen des Cursors im Puffer
;------------------------------------------------
;
CI:	push	HL
	ld	HL,(CURSR)
	ld	(HL),5FH			;"_"
	call	COPY			;Puffer anzeigen
	push	BC
	call	TCONIN			;Warten auf Zeichen
	pop	BC
	ld	(HL),20H			;"_" weg
	call	COPY			;Puffer anzeigen
	pop	HL
	cp	CR			;Test enter
	ret	z
	cp	SPACE			;Test space
	ret	z
	cp	STOP			;Test stop -> CY=1
	scf
	ret	z
	or	A			;sonst Z=0, CY=0
	ret
;
;Test auf ASCII-Hex-Ziffer
;-------------------------
;
TEHEX:	cp	67h			;Eing A Zeichen
	ccf
	ret	c
	cp	61h
	jr	c,TEHEX1
	sub	20h
	ret
TEHEX1: cp	47H			;Eing A Zeichen
	ccf
	ret	c			;Ausg CY=0 wenn Hex-Ziffer
	cp	41H			;       =1 sonst
	ret	nc
TEZIF:	cp	3AH
	ccf
	ret	c
	cp	30H
	ret
;
;Wandlung ASCII - Hex
;--------------------
;
ASHEX:	sub	30H			;Eing A Zeichen
	cp	10			;Ausg A Hex
	ret	c
	sub	7
	ret
;
;Adresse ausgeben auf Puffer
;---------------------------
;
PUTAD:	ld	A,H			;Eing HL
	call	PUTBY
	ld	A,L
;
;Byte ausgeben auf Puffer
;------------------------
;
PUTBY:	push	AF			;Eing A Byte
	rrca
	rrca
	rrca
	rrca
	call	PUTBY1
	pop	AF
PUTBY1:	and	0FH
	add	A,90H
	daa
	adc	A,40H
	daa
	jr	CO
;
;Zeichenkette auf Puffer
;-----------------------
;
STRNG:	push	AF			;Eing DE Puffer
STRN1:	ld	A,(DE)			;Abbruch mit BIT 7
	inc	DE
	call	CO
	add	A,A			;Ende ?
	jr	nc,STRN1
	pop	AF
	ret
;
;Kdo-Zeichen ausgeben
;--------------------
;
OPENK:	ld	DE,TXTPR		;Eing A Kdo-Zeichen
STRCO:	call	STRNG
	jr	CO
;
;BYTE + SPACE auf Puffer
;-----------------------
;
PUTBS:	call	PUTBY
;
;SPACE auf Puffer
;----------------
;
SPOUT:	ld	A,SPACE
;
;Zeichenausgabe auf Puffer
;-------------------------
;
CO:	push	AF		;Eing A Zeichen
	push	HL
	and	7FH
	ld	HL,(CURSR)
	cp	CR
	call	z,CLEAR
	cp	20H
	jr	c,CO1
CO0:	ld	(HL),A
	push	de
	ex	de,hl
	ld	hl,PUFF+LPUF-2	;Test Pufferende
	and	a
	sbc	hl,de
	ex	de,hl
	pop	de
	jr	c,CO1
	inc	HL
CO1:	ld	(CURSR),HL
	pop	HL
	pop	AF
	ret
CO2:	push	af
	push	hl
	ld	hl,(CURSR)
	jr	CO0
;
CLEAR:	push	BC		; Puffer loeschen
	ld	HL,PUFF+LPUF
	ld	B,LPUF
CLEAR1:	dec	HL
	ld	(HL),20H
	djnz	CLEAR1
	pop	BC
	ret
;
; Ausgabe des Puffers
;
COPY:	push	HL
	push	DE
	push	BC
	push	AF
	call	PUTPUF
	pop	AF
	pop	BC
	pop	DE
	pop	HL
	ret
;
; Register ablegen
; ----------------
;
RPUSH:	di
	ld	(BIOSP),SP
	ld	SP,A2RET+1
	ex	AF,AF'
	exx
	push	AF
	push	BC
	push	DE
	push	HL
	exx
	ex	AF,AF'
	push	IX
	push	IY
	push	AF
	push	BC
	push	DE
	push	HL
	ld	HL,(IRSPL3)
	push	HL		;user	SP
	ld	E,(HL)
	inc	HL
	ld	D,(HL)
	push	DE		;PC
	ld	SP,(BIOSP)
	ei
	ret
;
; Register restaurieren
; ---------------------
;
RPOP:	di
	ld	(BIOSP),SP
	ld	SP,PC1RET
	pop	DE		;PC
	pop	HL		;SP
	ld	(IRSPL3),HL
	ld	(HL),E
	inc	HL
	ld	(HL),D
	pop	HL
	pop	DE
	pop	BC
	pop	AF
	pop	IY
	pop	IX
	ex	AF,AF'
	exx
	pop	HL
	pop	DE
	pop	BC
	pop	AF
	ex	AF,AF'
	exx
	ld	SP,(BIOSP)
	ei
	ret
;
TXTRC2:	defb	0E1H		;a Reihenfolge
	defb	0E6H		;f muss bleiben !
	defb	0E2H		;b
	defb	0E3H		;c
	defb	0E4H		;d
	defb	0E5H		;e
	defb	0E8H		;h
	defb	0ECH		;l
	defb	'I'		;IX
	defb	0D8H
	defb	'I'		;IY
	defb	0D9H
TXTRC1:	defb	0C1H		;A 1. Registersatz
	defb	0C6H		;F
	defb	0C2H		;B
	defb	0C3H		;C
	defb	0C4H		;D
	defb	0C5H		;E
	defb	0C8H		;H
	defb	0CCH		;L
	defb	'S'		;SP
	defb	0D0H
	defb	'P'		;PC
	defb	0C3H
	defb	0		;Tab.ende
;
TXTPR:	defb	CR		;Prompt
	defm	'STOP:'
	defb	SPX
;*********************************************
