;*******************************************
;RAM fuer logischen Floppy-Treiber fuer BIC
;Filename: BICDIRA.S
;
;STAND: 09.05.89 / Ludewig
;*******************************************
;Vereinbarungen fuer Varianten
;===========================================
;
	COND	DISKLU.EQ.0	;bei DSE2 im ROM
				;sonst hier im RAM
;
DSKDS	EQU	1	;Unterstuetzung zweiseitiger LW
DSK80	EQU	1	;Unterstuetzung 80-spuriger LW
ENWRIT	EQU	1	;Schreiben auf Disk unterstuetzt
DBUFSZ	EQU	10	;Puffergroesse = 1024
AUTFER	EQU	1	;Unterstuetzung autom. Formaterkennung
IBMFRM	EQU	AUTFER	;Unterstuetzung IBM-Format von SIOS
ERRVAR	EQU	1	;mit BIOS-Fehlermeldg bei Floppy-Fehler
	ENDC
;*******************************************
;
LFRAMA:			;Log. Floppy-RAM Anf.
;*******************************************
;Floppy-LDIR
;
FLLDIR:	DEFS	19
;
;SFLLDI	PUSH	AF
;	IN	A,(PPIA)
;	PUSH	AF		;Istbank retten
;SFLLD1	LD	A,0AAH		;alles Bank 2
;	OUT	(PPIA),A
;
;	LD	A,B
;	OR	C
;	JR	Z,SFLLD2
;	LDIR			;umspeichern
;
;SFLLD2	POP	AF
;	OUT	(PPIA),A	;Bank zurueck
;	POP	AF
;	RET
;*******************************************
; Fehlermeldung Disk I/O Error
;
DERRMS	COND	ERRVAR
	DEFS	2	;0dh,0ah
	DEFS	9	;'BIOS-Err '
DERRCD	DEFS	4	;'XX: '
DERRRW	DEFS	9	;'Write LW=' bzw. 'Read  LW='
DERRLW	DEFS	4	;'X T='
DERRTR	DEFS	6	;'XX Si='
DERRSI	DEFS	5	;'X Se='
DERRSC	DEFS	2	;'XX'
	DEFS	2	;07h,0
	ENDC
;*******************************************
; Struktur CDB-Flag
;
; +0: cdbfl	;Flags	(Struktur angepasst an ftkom)
DIOF00	EQU	0	;** frei ** (frueher Verify nach Schreiben) ?s. Puffer-CDB ?
DIOFID	EQU	1	;fest	;=1, wenn nur Sektid. zu lesen
DIOFWR	EQU	2	;fest	;=1, wenn Schreiben
DIOFFM	EQU	3	;fest	;=1, wenn temporaer FM-Format erzwungen
DIOFTR	EQU	4		;=1, wenn keine Fehlermeldung (und -behandlg)
DIOFHD	EQU	5		;=1, wenn Kopf hochnehmen ("headup")
DIOFPS	EQU	6		;=1, wenn trk,sid,sec schon physisch
DIOFS1	EQU	7	;fest	;=1, wenn Rueckseite (Aend CP/A !)
;
;*******************************************
; CDB fuer Bestimmung Spurformat (--> DIOCDB)
;
DFRCDB:	COND	AUTFER
DFRFLG:	DEFS	1	;(1.SHL.diofid)+(1.SHL.dioftr)
			;Lesen Sektorid., kein Fehlerprotokoll
DFRDEV:	DEFS	1	;0ffh	;Geraet
DFRTRK:	DEFS	1	;0ffh	;Spur
	DEFS	1	;0ffh	;Seite (bel.)
	DEFS	1	;1	;Sektor (bel.)
	DEFS	1	;0	;Sektorlaengencode (bel.)
	DEFS	1	;1	;Sektoranzahl (>0)
	DEFS	2	;fl02	;dorthin Sektorid hinterlegt
	ENDC
;*******************************************
; Puffer-CDB (--> DIOCDB)
;
DBCDB:	COND	AUTFER.OR.(DBUFSZ.GT.7)
DBFLG:	DEFS	1	;0
;	------------------------
DBF00	EQU	DIOF00		;=1, wenn Puffer erst gelesen
				;    werden muss ?s. DSKTRA ??
DBFWR	EQU	DIOFWR		;=1, wenn Puffer durch
				;    Schreiben veraendert
DBFFM	EQU	DIOFFM 		;=1, wenn temporaer FM zu erzwingen
DBFTR	EQU	DIOFTR		;=1, wenn mit Fehlerprotokoll
				;restliche Bits immer =0
;	------------------------
DBDEV:	DEFS	1	;0ffh	;Geraet
DBTRK:	DEFS	1	;0ffh	;Spur
DBSID:	DEFS	1	;0ffh	;Seite
DBSEC:	DEFS	1	;0ffh	;Sektor
DBSLC:	DEFS	1	;0ffh	;Sektorlaengencode
DBSNB:	DEFS	1	;0ffh	;Sektoranzahl
	ENDC
;	------------------------
	COND DBUFSZ.GT.7
DBDMA:	DEFS	2	;dbuf	;Transferadresse
	ENDC
;	------------------------
	COND AUTFER.AND.(.NOT.(DBUFSZ.GT.7))
DBDMA:	DEFS	2	;dirbuf	;Transferadresse
	ENDC
;*******************************************
; CDB fuer ungepufferte E/A (-->DIOCDB)
;
DUCDB:
DUFLG:	DEFS	1	;0
;	------------------------
DUFWR	EQU	DIOFWR 		;=1, wenn write-Aufruf
DUFFM	EQU	DIOFFM 		;=1, wenn temporaer FM zu erzwingen
				;restliche Bits immer =0
;	------------------------
DUDEV:	DEFS	1	;0	;Geraet
DUTRK:	DEFS	1	;0ffh	;Spur
	DEFS	1	;0ffh	;Seite
DUSEC:	DEFS	1	;0ffh	;Sektor
	DEFS	1	;0	;128 Bytes Sektorlaenge
	DEFS	1	;1	;immer nur 1 Sektor
DUDMA:	DEFS	2	;0ffffh	;Transferadresse
;*******************************************
; Pufferzugriff
;
	COND	ENWRIT.AND.(DBUFSZ.GT.7)
UNACNT:	DEFS	4	;0,0ffh,0ffh,0
UNADEV	EQU	UNACNT+1
UNATRK	EQU	UNACNT+2
UNASEC	EQU	UNACNT+3
	ENDC
;	------------------------
	COND	DBUFSZ.GT.7
DBNB:	DEFS	1	;0ffh
DWRTYP:	DEFS	1	;0ffh
DBERRF:	DEFS	1	;0	;Ergebnisflag letztes dbtran
	ENDC
;*******************************************
;%%% Abbildung mehrerer log. LW auf phys. LW 0
;
LPTAB:	DEFS	1	;log. LW fuer phys. LW 0
LPCHNG:	DEFS	2	;0dh,0ah
	DEFS	6	;'Disk. '
LPCHLG	DEFS	32	;'X in DSE stecken; dann Taste "*"'
	DEFS	2	;07h,0
;*******************************************
;Anzeige Diskettenkapazitaet
;
DISKAP	DEFS	2	;0DH,0AH
	DEFS	3	;'LW '
DISKA5	DEFS	6	;'X=XXXK'
	DEFS	3	;0DH,0AH,0
;*******************************************
;Paramterfeld fuer phys. floppy-Routine (Aend CP/A !)
;
FLKDO:	DEFS	1	;80h	;Kommando
FLDEV:	DEFS	1	;0	;Laufwerk
FLTRK:	DEFS	1	;0	;Spur
FLSID:	DEFS	1	;0	;Seite
FLSEC:	DEFS	1	;1	;Sektor
FLSLC:	DEFS	1	;0	;Sektorlaengencode
FLGAP:	DEFS	1	;0eh	;gap 3
FLSNB:	DEFS	1	;1	;Sektorzahl
FL08:	DEFS	1	;1	;0/1  FM/MFM (BIC: nur MFM!)
FL09:	DEFS	1	;1	;Schritte von Spur zu Spur
FLDMA:	DEFS	2	;0	;Transferadresse
FL12:	DEFS	2	;0	;Adresse Drive Param Block
FL14:	DEFS	1	;0	;Ergebnis-Status
;*******************************************
; Tabelle der Adressen der DPH's
;
DPHATB:	DEFS	32	;defw dpha...dphp
;*******************************************
;
;DISK-PARAMETER-BLOECKE  -  S T R U K T U R
;===========================================
;
;CP/M-STANDARD-DISK-PARAMETER-BLOCK  -  S T R U K T U R
;
DPBSPT	EQU	0	;(dw)	128-Sektoren pro Spur (Formaterk)
DPBBLS	EQU	2	;(db)	blockshift (3=1K, 4=2K) (Formaterk)
DPBBLM	EQU	3	;(db)	blockmask (Formaterk)
DPBEXM	EQU	4	;(db)	extentmask (Formaterk)
DPBSIZ	EQU	5	;(dw)	Kapazitaet -1 in Bloecken (Formaterk)
DPBDIR	EQU	7	;(dw)	Anzahl -1 DIR-Eintraege (Formaterk)
DPBALC	EQU	9	;(dw)	Allocation-Bits fuer DIR (Formaterk)
DPBCHK	EQU	11	;(dw)	Check-Size fuer 'R/O'-Test (Formaterk)
DPBOFS	EQU	13	;(dw)	Zahl der Systemspuren (Formaterk)
;-------------------------------------------
;DISKETTEN-PARAMETER (NICHT-STANDARD-DBP)  -  S T R U K T U R
;
XDPBI	DEFL	15
DPBFLG	EQU	XDPBI	;(db)	Flags, i.a. alle =0
;	------------------------
DPBFSM	EQU	3	;	0..3 Zahl der abweichend vom
			;	restlichen Spurformat mit
			;	26*128 formatierten Spuren (Formaterk)
DPBFFM	EQU	2	;	=1, wenn FM-Aufzeichung zu erzwingen
			;	    (d.h. FM-Disk in MFM-Laufwerk) (FORMATB)
DPBFSV	EQU	3	;	=1, wenn Double sided zu betreiben,
			;	    indem von aussen nach innen
			;	    und auch Rueckseite von aussen
			;	    nach innen
			;	=0, wenn Double sided zu betreiben,
			;	    indem zunaechst von aussen nach
			;	    innen und Rueckseite von innen
			;	    nach aussen
			;	immer mit dpbf86+dpbfds zusammen setzen! (FORMATB)
DPBF86	EQU	4	;	=1, dpbfsv benutzen
			;	=0, wenn Double sided zu betreiben,
			;	    indem ungerade logische Spuren
			;	    auf der Rueckseite liegen
			;	immer mit dpbfds zusammen setzen! (FORMATB)
DPBFDS	EQU	5	;	=1, wenn Double sided zu betreiben (Formaterk)
DPBFRM	EQU	6	;	=1, wenn keine autom. Format-
			;	    erkennung in Seldsk (FORMATB)
DPBFND	EQU	7	;	=1, wenn abweichende DPB-Struktur
			;	    (keine Disketten) (FORMATB)
;	------------------------
XDPBI	DEFL	XDPBI+1
DPBSLC	EQU	XDPBI	;(db)	Sektorlaengencode (Formaterk)
;
XDPBI	DEFL	XDPBI+1
DPBBFM	EQU	XDPBI	;(db)	Puffermaske, d.h. Anzahl der 128er
			;	Sektoren im Puffer -1 (konst/FORMATB)
			;	- muss < 2**(dbufsz-7) sein,
			;	- muss < 2**dpbslc sein, wenn phys.
			;	  Sektornummern in dpbstr nicht monoton
XDPBI	DEFL	XDPBI+1
DPBSTP	EQU	XDPBI	;(db)	Stepimpulse pro Spurpositionierung
			;	1 oder 2 (Formaterk)
XDPBI	DEFL	XDPBI+1
DPBSN0	EQU	XDPBI	;(db)	Verschiebung der Sektor-Numm. auf Rueckseite
			;	wenn <>0, so statt side =1 side=0 im SektId! (konst/FORMATB)
XDPBI	DEFL	XDPBI+1
DPBTRK	EQU	XDPBI	;(db)	log. Anzahl Spuren (Formaterk)
;-------------------------------------------
;PHYS. LAUFWERKSNUMMER  -  S T R U K T U R
;
XDPBI	DEFL	XDPBI+1
DPBDNR	EQU	XDPBI	;(db)	physische Laufwerksnummer
;-------------------------------------------
;LAUFWERKS-PARAMETER (SCP1715-DRIVE-PARAMETER-BLOCK)  -  S T R U K T U R
; fuer MFS 1.6
;
XDPBI	DEFL	XDPBI+1
DPBDRT	EQU	XDPBI	;(db)	Laufwerkstyp:
;	------------------------
DPBTDS	EQU	0	; =0 bei SS, =1 bei DS
DPBTDD	EQU	3	; =0 bei SD (FM), =1 bei DD (MFM)
DPBT5Z	EQU	4	; =0 bei 8", =1 bei 5"
DPBT80	EQU	5	; =0 bei nicht 80-Spur, =1 bei 80-Spur
DPBT52	EQU	7	; =0 bei max 26 ,=1 bei max 52 Sekt./Spur (8" MFM)
;	------------------------
XDPBI	DEFL	XDPBI+1
DPBTRA	EQU	XDPBI	;(db)	1. Spur mit Praekompensation
;
XDPBI	DEFL	XDPBI+1
DPBSTI	EQU	XDPBI	;(db)	Schrittzeit SRT in ms
;
XDPBI	DEFL	XDPBI+1
DPBHLA	EQU	XDPBI	;(db)	Kopfberuhigung nach Anddruck HLT in ms
;
XDPBI	DEFL	XDPBI+1
DPBSPA	EQU	XDPBI	;(db)	Kopfberuhigung nach Step in ms
;
XDPBI	DEFL	XDPBI+1
DPBCUA	EQU	XDPBI	;(db)	1. Spur mit Schreibstrombegrenzung
;
XDPBI	DEFL	XDPBI+1
DPBOPT	EQU	XDPBI	;(db)	Optionen
;	------------------------
			;Bit 0-2 frei (=0)
DPBONV	EQU	3	; =0 mit Verify, =1 ohne Verify nach Schreiben
			;Bit 4-7 frei (=0)
;	------------------------
XDPBI	DEFL	XDPBI+1
DPBDU7	EQU	XDPBI	;(db)	Kopfentladezeit HUT in ms
;
XDPBI	DEFL	XDPBI+1
DPBPRT	EQU	XDPBI	;(db)	Praecompensationszeit (bei BIC ign.)
;
XDPBI	DEFL	XDPBI+1
DPBDU9	EQU	XDPBI	;(db)	frei (=0)
;
XDPBI	DEFL	XDPBI+1
DPBPTR	EQU	XDPBI	;(db)	Gesamtzahl physische Spuren (40/77/80)
;-------------------------------------------
;PHYSISCHE SEKTOR-TRANSLATE-TABELLE  -  S T R U K T U R
;
XDPBI	DEFL	XDPBI+1
DPBSTR	EQU	XDPBI	;(ds26)	entspr. phys. Sektoren pro Seite (Formaterk)
XDPBI	DEFL	XDPBI+26
;===========================================
DPBLNG	EQU	XDPBI	;(max.) Laenge eines DPB
;*******************************************
; Die Steuertabellen sind so dimensioniert, dass folgende Parameter
; moeglich sind (durch Dienstprogramm FORMATB von aussen setzen):
; 800k Kapazitaet
; 256 Dir-Eintraege
; 26 phys. Sektoren pro Spur(seite)
; Damit sind alle gaengigen Formate (800, 780, 624, 200, 148) einstellbar!
;*******************************************
;
; Laufwerk A: phys. LW in DSE
;===========================================
;
;DISK-PARAMETER-HEADER  LW A
;
DPHA:	DEFS	2 ;defw 0 	;kein Sektortranslate
	DEFS	6 		;BDOS Spur, Sektor, Dir
	DEFS	2 ;defw DIRBUF
 	DEFS	2 ;defw DPBA
	DEFS	2 ;defw CHKA
	DEFS	2 ;defw ALVA
;
;CP/M-STANDARD-DISK-PARAMETER-BLOCK  LW A
; fuer BIC Standard: 5*1024*160, 4 Systemspuren
;
DPBA:	DEFS	2 ;defw 40	;Sekt/Spur
	DEFS	1 ;defb 4	;2k Bloecke
	DEFS	1 ;defb 15
	DEFS	1 ;defb 0
	DEFS	2 ;defw 780/2-1
	DEFS	2 ;defw 128-1	;Dir Entries
	DEFS	2 ;defb 0C0h,0
	DEFS	2 ;defw 128/4
	DEFS	2 ;defw 4	;Systemspuren
;
;DISKETTEN-PARAMETER (NICHT-STANDARD-DBP)  LW A
;
	DEFS	1 ;defb 00100000b ;Floppy-DPB, DS betreiben
	DEFS	1 ;defb 3	;1k Sektorlaenge
	DEFS	1 ;defb 8-1	;8 128er Sektoren im Puffer
	DEFS	1 ;defb 1	;1 Stepimpuls von Spur zu Spur
	DEFS	1 ;defb 0	;kein Weiternummerieren auf Rueckseite
	DEFS	1 ;defb 160	;160 log. Spuren
;
;PHYS. LAUFWERKSNUMMER  LW A
;
	DEFS	1 ;defb	0	;phys. LW-Nr.
;
;LAUFWERKS-PARAMETER (SCP1715-DRIVE-PARAMETER-BLOCK)  LW A
; fuer MFS 1.6
;
	DEFS	1 ;defb	00111001b ;80 Spur/5"/MFM/DS
	DEFS	1 ;defb	80	; 1. Spur mit Praekompensation
	DEFS	1 ;defb	4	;Schrittzeit SRT in ms
	DEFS	1 ;defb	4	;Kopfberuhigungszeit nach Andruck HLT in ms
	DEFS	1 ;defb	10	;Kopfberuhigungszeit nach Step in ms
	DEFS	1 ;defb	80	; 1. Spur mit Schreibbegrenzung (bei BIC ign.)
	DEFS	1 ;defb	0	;Optionen, mit Verify nach Schreiben
	DEFS	1 ;defb	32	;Kopfentladezeit HUT in ms
	DEFS	1 ;defb	0	;Praekompzeit (bei BIC ignoriert)
	DEFS	1 ;defb	0	;frei
	DEFS	1 ;defb	80	;LW hat 80 phys. Spuren
;
;PHYSISCHE SEKTOR-TRANSLATE-TABELLE  LW A
;
	DEFS	26		;Reihenfolge fuer Sektorzugriff
;
;CHECK- U. ALLOCATION-VEKTOR  LW A
;
CHKA:	DEFS	192/4		;reicht fuer 192 Dir-Entries
ALVA:	DEFS	(800/2)/8	;reicht fuer 800k
;*******************************************
;
; Laufwerk B: 1. phys. Beistell-LW oder zusaetzlich in DSE
;===========================================
;
;DISK-PARAMETER-HEADER  LW B
;
DPHB:	DEFS	2 ;defw 0 	;kein Sektortranslate
	DEFS	6 		;BDOS Spur, Sektor, Dir
	DEFS	2 ;defw DIRBUF
 	DEFS	2 ;defw DPBB
	DEFS	2 ;defw CHKB
	DEFS	2 ;defw ALVB
;
;CP/M-STANDARD-DISK-PARAMETER-BLOCK  LW B
; fuer BIC Standard: 5*1024*160, 4 Systemspuren
;
DPBB:	DEFS	2 ;defw 40	;Sekt/Spur
	DEFS	1 ;defb 4	;2k Bloecke
	DEFS	1 ;defb 15
	DEFS	1 ;defb 0
	DEFS	2 ;defw 780/2-1
	DEFS	2 ;defw 128-1	;Dir Entries
	DEFS	2 ;defb 0C0h,0
	DEFS	2 ;defw 128/4
	DEFS	2 ;defw 4	;Systemspuren
;
;DISKETTEN-PARAMETER (NICHT-STANDARD-DBP)  LW B
;
	DEFS	1 ;defb 00100000b ;Floppy-DPB, DS betreiben
	DEFS	1 ;defb 3	;1k Sektorlaenge
	DEFS	1 ;defb 8-1	;8 128er Sektoren im Puffer
	DEFS	1 ;defb 1	;1 Stepimpuls von Spur zu Spur
	DEFS	1 ;defb 0	;kein Weiternummerieren auf Rueckseite
	DEFS	1 ;defb 160	;160 log. Spuren
;
;PHYS. LAUFWERKSNUMMER  LW B
;
	DEFS	1 ;defb	0/1	;phys. LW-Nr.
;
;LAUFWERKS-PARAMETER (SCP1715-DRIVE-PARAMETER-BLOCK)  LW B
; fuer MFS 1.6
;
	DEFS	1 ;defb	00111001b ;80 Spur/5"/MFM/DS
	DEFS	1 ;defb	80	; 1. Spur mit Praekompensation
	DEFS	1 ;defb	4	;Schrittzeit SRT in ms
	DEFS	1 ;defb	4	;Kopfberuhigungszeit nach Andruck HLT in ms
	DEFS	1 ;defb	10	;Kopfberuhigungszeit nach Step in ms
	DEFS	1 ;defb	80	; 1. Spur mit Schreibbegrenzung (bei BIC ign.)
	DEFS	1 ;defb	0	;Optionen, mit Verify nach Schreiben
	DEFS	1 ;defb	32	;Kopfentladezeit HUT in ms
	DEFS	1 ;defb	0	;Praekompzeit (bei BIC ignoriert)
	DEFS	1 ;defb	0	;frei
	DEFS	1 ;defb	80	;LW hat 80 phys. Spuren
;
;PHYSISCHE SEKTOR-TRANSLATE-TABELLE  LW B
;
	DEFS	26		;Reihenfolge fuer Sektorzugriff
;
;CHECK- U. ALLOCATION-VEKTOR  LW B
;
CHKB:	DEFS	192/4		;reicht fuer 192 Dir-Entries
ALVB:	DEFS	(800/2)/8	;reicht fuer 800k
;*******************************************
;
; Laufwerk C: 2. phys. Beistell-LW
;===========================================
;
;DISK-PARAMETER-HEADER  LW C
;
DPHC:	DEFS	2 ;defw 0 	;kein Sektortranslate
	DEFS	6 		;BDOS Spur, Sektor, Dir
	DEFS	2 ;defw DIRBUF
 	DEFS	2 ;defw DPBC
	DEFS	2 ;defw CHKC
	DEFS	2 ;defw ALVC
;
;CP/M-STANDARD-DISK-PARAMETER-BLOCK  LW C
; fuer BIC Standard: 5*1024*160, 4 Systemspuren
;
DPBC:	DEFS	2 ;defw 40	;Sekt/Spur
	DEFS	1 ;defb 4	;2k Bloecke
	DEFS	1 ;defb 15
	DEFS	1 ;defb 0
	DEFS	2 ;defw 780/2-1
	DEFS	2 ;defw 128-1	;Dir Entries
	DEFS	2 ;defb 0C0h,0
	DEFS	2 ;defw 128/4
	DEFS	2 ;defw 4	;Systemspuren
;
;DISKETTEN-PARAMETER (NICHT-STANDARD-DBP)  LW C
;
	DEFS	1 ;defb 00100000b ;Floppy-DPB, DS betreiben
	DEFS	1 ;defb 3	;1k Sektorlaenge
	DEFS	1 ;defb 8-1	;8 128er Sektoren im Puffer
	DEFS	1 ;defb 1	;1 Stepimpuls von Spur zu Spur
	DEFS	1 ;defb 0	;kein Weiternummerieren auf Rueckseite
	DEFS	1 ;defb 160	;160 log. Spuren
;
;PHYS. LAUFWERKSNUMMER  LW C
;
	DEFS	1 ;defb	2	;phys. LW-Nr.
;
;LAUFWERKS-PARAMETER (SCP1715-DRIVE-PARAMETER-BLOCK)  LW C
; fuer MFS 1.6
;
	DEFS	1 ;defb	00111001b ;80 Spur/5"/MFM/DS
	DEFS	1 ;defb	80	; 1. Spur mit Praekompensation
	DEFS	1 ;defb	4	;Schrittzeit SRT in ms
	DEFS	1 ;defb	4	;Kopfberuhigungszeit nach Andruck HLT in ms
	DEFS	1 ;defb	10	;Kopfberuhigungszeit nach Step in ms
	DEFS	1 ;defb	80	; 1. Spur mit Schreibbegrenzung (bei BIC ign.)
	DEFS	1 ;defb	0	;Optionen, mit Verify nach Schreiben
	DEFS	1 ;defb	32	;Kopfentladezeit HUT in ms
	DEFS	1 ;defb	0	;Praekompzeit (bei BIC ignoriert)
	DEFS	1 ;defb	0	;frei
	DEFS	1 ;defb	80	;LW hat 80 phys. Spuren
;
;PHYSISCHE SEKTOR-TRANSLATE-TABELLE   LW C
;
	DEFS	26		;Reihenfolge fuer Sektorzugriff
;
;CHECK- U. ALLOCATION-VEKTOR  LW C
;
CHKC:	DEFS	192/4		;reicht fuer 192 Dir-Entries
ALVC:	DEFS	(800/2)/8	;reicht fuer 800k
;*******************************************
;
; Laufwerk D: RAM-Floppy im Bildspeicher (128K)
;===========================================
;
;DISK-PARAMETER-HEADER  LW D
;
DPHD:	DEFS	2 ;defw 0 	;kein Sektortranslate
	DEFS	6 		;BDOS Spur, Sektor, Dir
	DEFS	2 ;defw DIRBUF
 	DEFS	2 ;defw DPBD
	DEFS	2 ;defw CHKD
	DEFS	2 ;defw ALVD
;
;CP/M-STANDARD-DISK-PARAMETER-BLOCK  LW D
; fuer 128K: 16*128*64, 0 Systemspuren
;
DPBD:	DEFS	2 ;defw 16	;Sekt/Spur
	DEFS	1 ;defb 3	;1k Bloecke
	DEFS	1 ;defb 7
	DEFS	1 ;defb 0
	DEFS	2 ;defw 128/1-1
	DEFS	2 ;defw 64-1	;Dir Entries
	DEFS	2 ;defb 0C0h,0
	DEFS	2 ;defw 64/4
	DEFS	2 ;defw 0	;Systemspuren
;
;DISKETTEN-PARAMETER (NICHT-STANDARD-DBP)  LW D
;
	DEFS	1 ;defb 80H	;RAM-Floppy-DPB
	DEFS	5		;Reserve
;
;CHECK- U. ALLOCATION-VEKTOR  LW D
;
CHKD:	DEFS	64/4		;reicht fuer 64 Dir-Entries
ALVD:	DEFS	(128/1)/8	;reicht fuer 128k
;*******************************************
;
; Laufwerk E: RAM-Floppy-Modul 64k (256k)
; (nicht Speicherresident !!)
;===========================================
;
;DISK-PARAMETER-HEADER  LW E
;
;DPHE:	DEFS	2 ;defw 0 	;kein Sektortranslate
;	DEFS	6 		;BDOS Spur, Sektor, Dir
;	DEFS	2 ;defw DIRBUF
; 	DEFS	2 ;defw DPBE
;	DEFS	2 ;defw CHKE
;	DEFS	2 ;defw ALVE
;
;CP/M-STANDARD-DISK-PARAMETER-BLOCK  LW E
; fuer BIC Standard: 5*1024*160, 4 Systemspuren
;
;DPBE:	DEFS	2 ;defw 16	;Sekt/Spur
;	DEFS	1 ;defb 3 (4)	;1k (2k) Bloecke
;	DEFS	1 ;defb 7 (15)
;	DEFS	1 ;defb 0
;	DEFS	2 ;defw 64/1-1 (256/2-1)
;	DEFS	2 ;defw 64-1 (128-1)	;Dir Entries
;	DEFS	2 ;defb 0C0h,0
;	DEFS	2 ;defw 64/4 (128/4)
;	DEFS	2 ;defw 0	;Systemspuren
;
;DISKETTEN-PARAMETER (NICHT-STANDARD-DBP)  LW E
;
;	DEFS	1 ;defb 80H	;RAM-Floppy-DPB
;	DEFS	5		;Reserve
;
;CHECK- U. ALLOCATION-VEKTOR  LW E
;
;CHKE:	DEFS	128/4		;reicht fuer 128 Dir-Entries
;ALVE:	DEFS	(256/2)/8	;reicht fuer 256k
;*******************************************
;
;CDB-Hilfsspeicher fuer diskio-Aufruf (-->FLKDO) (Aend CP/A !)
;
DIOCDB
;	------------------------
DIOFLG	DEFS	1	;Flag
DIODEV	DEFS	1	;Geraet
DIOTRK	DEFS	1	;Spur
DIOSID	DEFS	1	;Seite
DIOSEC	DEFS	1	;Sektor
DIOSLC	DEFS	1	;Sektorlaengencode
DIOSNB	DEFS	1	;Sektoranzahl
DIODMA	DEFS	2	;Transferadresse
;	------------------------
DIOCDL	EQU	$-DIOCDB ;Anzahl der Bytes
;*******************************************
;
DIRBUF:	DEFS	80H	;Dir-Puffer
;
;*******************************************
;
DBUF:	DEFS	2**DBUFSZ ;Diskettenpuffer (400H)
;
;*******************************************
