;*******************************************
; RAM-Bereiche fuer SCPX
; Stand: 17.05.89
; File: SCPRAM.S
;*******************************************
;   (RAM liegt im RBASIC parallel zu MUPUK0 !)
;
;IRSP3E	defs	1						! s. MUPUK0 !
;	defs	82	;Stack BIOS-Monitor			! s. MUPUK0 !
;IRSPL3	defs	2						! s. MUPUK0 !
;===========================================
;   (RAM liegt im RBASIC parallel zu FIRERL !)
;
;ZEISFL	defs	1	;7F - normaler, 80 - alternat. ZS	! s. FIRERL !
;ZEISA	defs	1	;normal ?				! s. FIRERL !
;INVEFL	defs	1	;akt. Zustand Farbbyte			! s. FIRERL !
;FKTAN1	defs	1	;Hilfszelle Fehleranzeige		! s. FIRERL !
;===========================================
;   (RAM liegt im RBASIC parallel zu MUPUK0 !)
;
;IRZ240	defs	1	;Zeitzaehler 240 ms			! s. MUPUK0 !
;FZELLE	defs	1	;Fehlerzelle fuer Anzeige		! s. MUPUK0 !
;SYNSEM	defs	1	;Verbot Stop-Zustand + BIOS-Monitor	! s. MUPUK0 !
;SYNFLG	defs	1	;Monitor-Flag				! s. MUPUK0 !
;H2PPIA	defs	1	;Merkzelle Systemzustand		! s. MUPUK0 !
;STATUP	defs	2	;Adresse fuer Anzeige			! s. MUPUK0 !
;STFLAG	DEFS	1	;Neuanzeige SCP-Statuszeile		! s. MUPUK0 !
;FUFLAG	DEFS	1	;     "     Fkt-Tastenbelegung		! s. MUPUK0 !
;SYNS2	DEFS	1	;Verbot BIOS-Monitor			! s. MUPUK0 !
;
;BIOSMO	DEFS	7	;BIOS-Monitor (Eintritt mit Taste)	! s. MUPUK0 !
;PCRET	DEFS	4	;Adr, wo System-IR eingeschoben wurde	! s. MUPUK0 !
;MONCAL	DEFS	41	;BIOS-Monitor (Eintritt mit RST 38H)	! s. MUPUK0 !
;DECHL	DEFS	22						! s. MUPUK0 !
;XSTOP4	DEFS	24	;PCALT <-> BIOSMO tauschen		! s. MUPUK0 !
;
;DISMO1	DEFS	7	;Verbieten BIOS-Monitor	 		! s. MUPUK0 !
;ENAMO1	DEFS	7	;Erlauben BIOS-Monitor			! s. MUPUK0 !
;
;===========================================
;BIOS-Monitor
;   (RAM liegt im RBASIC parallel zu MUPUK0 !)
;
;CURSR	DEFS	2	;Kursor in Puffer			! s. MUPUK0 !
;MADR	DEFS	2	;anzuzeigende Speicheradr		! s. MUPUK0 !
;STATU1	DEFS	2	;Zwischenspeicher fuer STATUP		! s. MUPUK0 !
;BIOSP	DEFS	2	;SP bei Aufruf				! s. MUPUK0 !
;PC1RET	DEFS	11	;1.Registersatz (PC,SP,HL,DE,BC,AF)	! s. MUPUK0 !
;A1RET	DEFS	1						! s. MUPUK0 !
;	DEFS	11	;2.Registersatz (IY,IX,HL,DE,BC,AF)	! s. MUPUK0 !
;A2RET	DEFS	1						! s. MUPUK0 !
;
;LPUF	EQU	80	;Pufferlaenge				! s. MUPUK0 !
;PUFF	DEFS	LPUF	;Zeilenpuffer fuer Monitor		! s. MUPUK0 !
;DPUFF	DEFS	16	;Puffer fuer D-Kdo			! s. MUPUK0 !
;===========================================
;
STZEIL	defs	80		;Statuszeile fuer Anzeige in BS-Zeile 25
STALW	equ	STZEIL		;aktuelles LW
STUSER	equ	STZEIL+1	;akt. user
STSATZ	equ	STZEIL+3	;akt. Zeichensatz
STLW	equ	STZEIL+5	;LW-Verteilung
STIO	equ	STZEIL+11	;Stellung IO-Byte
STDSKF	equ	STZEIL+14	;Disk-Formate
STTAST	equ	STZEIL+38	;Tastatur-Puffer
STTREI	equ	STZEIL+79	;Verklemmungsanzeige Treiber
;-------------------------------------------
IORET	DEFS	1	;Kopie SCP-Adr. 3
LWRET	DEFS	1	;Kopie SCP-Adr. 4
DFEPU	DEFS	80	;Disketten-Fehlerpuffer
;===========================================
*EJEC
;
;;CCP-RAM: Kopien aus ROM
;
;alle Marken, die Adressen des ROM bezeichnen, enden mit 0
;alle Marken, die Adressen des RAM bezeichnen, enden mit 2
;-------------------------------------------
;
CRAM2:			;Anfang des CCP-RAM
;-----------------------
COMBF2:	DEFS	1	;CCP-Kommandopufferlaenge
COMBL2:	DEFS	1	;aktuelle Kommandolaenge
COMBT2:	DEFS	127	;Beginn des Kommandopuffers (1.Zeichen)
;
SFD2:	DEFS	14	;$$$.SUB  FCB	Drive, Name, Typ, EX, S1
SFS22:	DEFS	1	;		S2 (BDOS-Flag Schreibzugriff)
SFRC2:	DEFS	17	;		RC (Record Counter)
SFCR2:	DEFS	4	;		CR (Current Record)
;
CBCHL2:	DEFS	8	;2 Byte ab (HL) in BC von anderem SLOT lesen
LDDR2:	DEFS	7	;LDDR
CBDR2:	DEFS	8	;CALL 5
ASTSV:
ETAB2:	DEFS	8	;Fehleradresstabelle
; -------------------------------
	DEFS	30H	;CCP-STACK
CST2:			;Vor dem Stack liegen konstante Daten im RAM.
			;Diese werden bei Warmstart des CCP regeneriert,
			;um vom Anwenderprogramm verursachte Stack-
			;ueberlaeufe zu reparieren.
			;Hinter dem Stack liegen veraenderliche Daten,
			;die erhalten bleiben muessen !
; -------------------------------
LDIR2:	DEFS	4	;LDIR
RTPA2:	DEFS	8	;Slotrueckschaltung ohne Registerveraenderung
RET2:	DEFS	8	;Rueckkehr aus transientem Kommando
ANCR2:	DEFS	5	;LD SP,(ASTSV)	RET
JPHL2:	DEFS	3	;OUT (PPIA),A	JP (HL)
CK12:	DEFS	3	;PATCH Warmstart CCP
CK22:	DEFS	3	;PATCH CCP-Kommando-Warteschleife
CK32:	DEFS	3	;PATCH CCPDEF vor Einstellen DRIVE/USER/DMA
; -------------------------------
ESEC2:	DEFS	4	;Fehlerbehandlungsprogramme
ESEL2:	DEFS	4	;LD HL,(nn)
EDRO2:	DEFS	4	;JP (HL)
EFRO2:	DEFS	4
;
; #### Achtung !!! #### TREND muss direkt vor der Tabelle stehen ####
	COND	(RSOLO.EQ.1).OR.(ELS.EQ.0)
NRESC	EQU	6	;ACHTUNG: Auch im ROM definiert !
LRESC	EQU	8
	ENDC
;
TREND:	DEFS	2		  ;kleinste Adresse fuer nachgeladene Treiber
RESC2:	DEFS	NRESC*(LRESC+2)+1 ;RAM-Tabelle der nachgeladenen residenten Kommandos
RESX2	EQU	RESC2		  ;1. Tabellenplatz
ENDX2	EQU	$	          ;Tabellenende + 1
; ##########################################
COMPP2:	DEFS	2	;Entschl. Zeiger Kommandopuffer
DCF71:	DEFS	2	;Parameterbeginn fuer Fehlermeldung
EXTZ:	DEFS	2	;Fuellstand EXT, Anfangsadresse des
;			;zuletzt geladenen Kommandos
DEFUS:	DEFS	1	;default user
DEFDV:	DEFS	1	;default drive, 0 entspricht Laufwerk A
SELUAK:	DEFS	1	;ausgewaehlter User bei SETUS (BDOS 32)
SYSDVC:	DEFS	1	;Kaltstart-Laufwerk, 0 entspricht LW A
SELDAK:	DEFS	1	;ausgewaehltes LW bei SELDSK (BDOS 14)
LFILE:	DEFS	2	;Filelaenge nach LODCOM, Vielfaches von 80H
DCF98:	DEFS	2	;Adresse des vorhergehenden Kommandos in
;			;der Tabelle der residenten Kommandos
PARBEG:	DEFS	2	;Parameterbeginnadresse im Kommandopuffer
DCF6E:	DEFS	1	;ist explizit LW angegeben ?
;			;0..nein, 1..LW A, 2..LW B, u.s.w.
DCF70:	DEFS	1	;ist SUB aktiv ?
;			;0..nein, 1..ja in LW A, u.s.w.
CSLOT:	DEFS	1	;CCP-interne SLOT-Zuordnung
CBDOS:	DEFS	2	;zur Regenerierung der BDOS-Adresse bei Warmstart
;-----------------------
CRAME:				;Ende des CCP-RAM
CRAML	EQU	CRAME-CRAM2	;Gesamtlaenge CCP-RAM
;
;===========================================
*EJEC
;===========================================
;Koepfe der BIOS-Rufe RAM
;   (RAM liegt im RBASIC parallel zu MUPUK0 !)
;
;BIORRA	 							! s. MUPUK0 !
;KCIBOOT:DEFS	5	;0					! s. MUPUK0 !
;KWBOOT	DEFS	5						! s. MUPUK0 !
;KCONST	DEFS	5	;2					! s. MUPUK0 !
;KCONIN	DEFS	5						! s. MUPUK0 !
;KCONOUT:DEFS	5	;4					! s. MUPUK0 !
;KLIST	DEFS	5						! s. MUPUK0 !
;KPUNCH	DEFS	5	;6					! s. MUPUK0 !
;KREADER:DEFS	5						! s. MUPUK0 !
;KHOME	DEFS	5	;8					! s. MUPUK0 !
;KSELDSK:DEFS	5						! s. MUPUK0 !
;KSETTRK:DEFS	5	;10					! s. MUPUK0 !
;KSETSEC:DEFS	5						! s. MUPUK0 !
;KSETDMA:DEFS	5	;12					! s. MUPUK0 !
;KREAD	DEFS	5						! s. MUPUK0 !
;KWRITE	DEFS	5	;14					! s. MUPUK0 !
;KLISTST:DEFS	5						! s. MUPUK0 !
;KSECTRAN:DEFS	5	;16					! s. MUPUK0 !
;KCONOST:DEFS	5						! s. MUPUK0 !
;KAUXIST:DEFS	5	;18					! s. MUPUK0 !
;KAUXOST:DEFS	5						! s. MUPUK0 !
;KDEVTBL:DEFS	5	;20					! s. MUPUK0 !
;-------------------------------------------
;
;BIOS-Rahmen RAM (muss auf "Koepfe der BIOS-Rufe" folgen!)
;   (RAM liegt im RBASIC parallel zu MUPUK0 !)
;
;BIORA	DEFS	33	;BIOS-Rahmen				! s. MUPUK0 !
;JPHLR	DEFS	1						! s. MUPUK0 !
;-------------------------------------------
;
;BIOS-Stack
;   (RAM liegt im RBASIC parallel zu MUHLP !)
;
;	DEFS	2*40+2	;BIOS-Stack (40 Plaetze)		! s. MUHLP !
;BIORST	DEFS	2	;Rettzelle SP				! s. MUHLP !
;-------------------------------------------
;   (RAM liegt im RBASIC parallel zu FNPTR !)
;
;TRBSCH	defs	29	;Verteilung ueber IO-Byte		! s. VARFOR !
;TRRUF2	defs	32	;Ein/Ausschaltung Statuszeichen		! s. VARFOR !
			; Warmst. bei Fehler			! s. VARFOR !
;TRTAB	defs	32	;Adresztabelle Treiber			! s. VARFOR !
;SLTAB	defs	16	;Slottabelle Treiber			! s. VARFOR !
;-------------------------------------------
RAMEND	defs	0
;*******************************************
