;****************************************************************
; FORMAT:							*
;	Disketten-Formatierungsprogramm	fuer BIC 		*
;	(Hardware LW 1.6 + FDC 8272)				*
;	Disk DS-DD-80 Spuren					*
;	Format:	5 * 1024  (2 Systemspuren) BIC-Standard mit	*
;		Sektorversatz	1 4 2 5 3			*
;	Nutzung	der phys.Routinen im Betriebssystem (bifm00)	*
; max.8 2-kByte-Bloecke (ausser Spur 0-2) koennen defekt sein	*
; Anzeige der defekten Bloecke nach Beendigung Formatieren	*
;
; Stand: 10.04.89
;
; File: BICFORMAT.S
;****************************************************************
;
CR	EQU	0DH
LF	EQU	0AH
BS	EQU	08H
;
CHOME	EQU	0CH	;BS-Steuerzeichen
ANZSEK	EQU	5	;Sektoranzahl auf einer Seite der Disk
ANZBLK	EQU	5	;Anzahl der 1-K-Bloecke auf einer Disk-Seite
SEKBLK	EQU	1	;Anzahl Sektoren je KByte
;**************************************************
;
	GLOBAL	FORMA0
FORMA0			;Programmbeginn
;
;
;Einlesen der benoetigten Parameter, Modifizierung der entspr.Schnittstellen
;---------------------------------------------------------------------------
INITB0:	LD	HL,SCHNR0	;Umladen Schnittstellen u Puffer in RAM
	LD	DE,SCHNR	; Zieladresse
	LD	BC,DBMEN0-SCHNR0+1 ; Laenge: SCHNR0...DBMEN0
	LDIR
;	--------	
MENUE	XOR	A
	LD	(LWOK),A	;kein gueltiges log. LW
	LD	DE,AMENUE
	CALL	ZKAUS		;Anzeige Anfangsmenue
	CALL	TEIN		;Einlesen drivename
;
	CP	3
	JP	Z,BREAK
	CP	CR
	JR	NZ,MEN10
	LD	A,'A'		;ENTER = log. LW A
;
MEN10	RES	5,A		;Erzeugen Grossbuchstaben
	SUB	'A'		;log. LW A = 0
	CP	16
	JR	NC,MENUE	;-->Falsches log. LW
;
	LD	C,A
	CALL	DGETPB
	JR	Z,MENUE		;-->Falsches log. LW
;	----------
	LD	A,0FFH
	LD	(LWOK),A	;Gueltiges log. LW
;
	LD	A,(IX+DPBOPT)
	LD	(HDPBOP),A	;Verify-Status retten
	SET	DPBONV,A	;Format ohne Verify
	LD	(IX+DPBOPT),A
;
	LD	A,(IX+DPBDNR)
	LD	(SCHNR+1),A	;phys. LW-Code in Schnittstellen laden
	LD	(SCHNF+1),A
;
	LD	DE,DPBDRT
	ADD	IX,DE
	LD	(SCHNR+12),IX
	LD	(SCHNF+12),IX	 ;Adr Drive-Parameter-Block
;
	LD	A,C		;A = log. LW
	LD	DE,1
	AND	A
	JR	Z,MEN30
MEN20	SLA	E
	RL	D		;DE = LW-Vektor
	DEC	A
	JR	NZ,MEN20
MEN30	LD	C,37		;log. LW durch BDOS ruecksetzen
	CALL	BBDOS		; (nicht BBDOSX !!)
;	--------	
	LD	DE,STECK
	CALL	ZKAUS		;Aufforderung zum Stecken der zu form.Disk
WART1:
	CALL	TEIN		;    Warten auf Betaetigen einer Taste
	CP	03H		;    ^C --> Abbruch
	JP	Z,BREAK		;	|
	CP	0DH		;    Unterscheidung ET1 = weiter/andere = warten
	JR	NZ,WART1	;-------+
	
INITB2:	CALL	SP0		;in allen ID-Puffern die Spurnr.auf 0 setzen und die
				;Schnittstellen	initialisieren
	
;Ende der Schnittstellenmodifizierung
;------------------------------------
	LD	DE,WARN
	CALL	ZKAUS		;Warnung,alle Files auf d.form.Disk werden geloescht
	
	CALL	TEIN		;warten auf 'J':-->formatieren
				; andere Taste:-->abbrechen
	RES	5,A		;Grossbuchstaben erzeugen
	CP	'J'
	JP	NZ,BREAK	;Abbruch des Programms
	
	LD	IX,SCHNR
	LD	(IX+0),80H
	CALL	BIFM00		;Kaltstart f.FDC
	LD	(IX+0),73H	;Code fuer Kontrollesen
	
	LD	HL,TRACK
	LD	(HL),80		;Spurzaehler laden (Rueckwaertszaehler !!)
	
	LD	HL,VRM
	LD	(HL),0		;Vorder-/Rueckseitenmerker
	
	LD	HL,DBLLGE
	LD	(HL),DBMEND-DBM+1
				;max.Laenge des DBM
	LD	B,(HL)
 
	LD	HL,DBM		;Adr.des DBM
	LD	(BLZEIG),HL	;Zeiger auf 1.freie Zelle des DBM
	
DBML:	LD	(HL),0
	INC	HL
	DJNZ	DBML		;DBM loeschen
	
	LD	HL,SFM
	LD	(HL),0		;Sektorform.merker (zaehlt def.128-Byte-Bloecke)
	
	LD	DE,FANZ1
	CALL	ZKAUS		;Leerzeile
	
;Vorbereitung fuer jeden Aufruf des Moduls 'bifm' bei neuer Spur
;---------------------------------------------------------------
INITB3:	LD	HL,SPFWDH
	LD	(HL),2		;Spurform.wdh.-Zaehler (nach Fehlern beim Formatieren)
	LD	HL,SFWDH
	LD	(HL),2		;Sektorform.wdh.-Zaehler (nach Fehlern bei Kontrollesen)
	
;Beginn Formatierung
;-------------------
INITB4:	LD	DE,FANZ
	CALL	ZKAUS		;Anzeige "Formatieren auf Spur: "
	
	LD	A,(VRM)
	LD	B,A
	LD	A,(SCHNF+2)
	ADD	A,A
	ADD	A,B		; 2 * Spur + Seite
	CALL	KON		; Konvertierung/Anzeige
	
	LD	IX,SCHNF
	CALL	BIFM00		;Form.einer Spur auf einer Seite der Disk
	LD	A,(IX+14)	;Status
	CP	0
	JP	Z,KONRD0	;Fehlerfrei --> nun Kontrollesen
	
;Behandlung von Fehlern nach Formatieren
;-->z.B.Status 40h vom FDC  (Ursachen/Bedeutung bis jetzt ungeklaert)
;auch moeglich z.B. LW-Hebel nicht geschlossen
;--------------------------------------------------------------------
FEBEFO:	LD	A,(IX+14)	;Status
	CP	52H		;Fehlercode f.LW nicht bereit
	JP	Z,BREAK3
	CP	53H		;Fehlercode f.Disk schreibgeschuetzt
	JP	Z,BREAK4
	
	LD	HL,SPFWDH	;Spurformatierwdh.-Zaehler
	DEC	(HL)
	JP	Z,BREAK		;nach 3-maliger vergeblicher Form.einer Spur
				;Programmabbruch,da f.diese Fehlerklasse z.Z. keine
	JP	INITB4		;Erklaerung existiert
	
;Kontrollesen einer Spur in 1-K-Bloecken
;---------------------------------------
KONRD0:	LD	A,ANZBLK	;Anzahl der 1-K-Bloecke auf einer Seite
	LD	(KLZ),A		;in den Kontrollese-Zaehler laden
	
	LD	IX,SCHNR	;-------+
	LD	A,(SCHNF+2)	;   gerade form.Spur
	LD	(IX+2),A	;   in schnr laden
				;	|
	LD	A,(VRM)		;	|==> Init.von schnr
	LD	(IX+3),A	;   Kopfnr.laden
	LD	(IX+4),1	;   1.zu beh.Sektor
	LD	(IX),73H	;-------+
	
KONRD1:	CALL	BIFM00		;Kontrollesen 1 kByte
	LD	A,(IX+14)	;Status
	CP	0
	JP	NZ,FEBEKL	;zur Fehlerbehandlung nach Kontrollesen
	
WNF:	LD	HL,KLZ	
	DEC	(HL)
	JP	Z,PRSEIT	;Spur o.k.,weiter mit naechster Spur
	
	LD	A,(IX+4)	;1.zu behandelnder Sektor
	LD	B,SEKBLK
	ADD	A,B		;auf naechstes KByte einstellen
	LD	(IX+4),A
	JP	KONRD1		;naechstes KByte kontrollesen
	
;Behandlung von Fehlern nach Kontrollesen --> 2-malige Wiederholung.
;Danach Eintragen in Errormap.Max 8 2-k-Bloecke duerfen defekt sein.
;Bei Fehlern in Spur 0-2 sofortiger Abbruch. Es bleibt
;dem Bediener ueberlassen,einen neuen Programmdurchlauf zu starten.
;------------------------------------------------------------------------
FEBEKL:	LD	HL,SFWDH	;Wdh.-Zaehler nach Fehler bei Kontrollesen
	DEC	(HL)
	JP	NZ,INITB4	;nochmaliges Form.der selben Spur
	LD	(HL),1		;Verhindern 'Quasi'-Endlosschleife
	
	LD	A,(IX+2)	;Spur,die gerade geprueft wurde
	CP	3
	JP	C,BREAK1	;System- bzw.Dir.-Spur darf keinen Fehler haben
	
	SUB	2		;Numerierung der Bloecke beginnt auf Spur 2
	ADD	A,A		;Anzahl d.vollstaendig form.Spuren ab Spur2/Kopf0
	LD	B,A
	LD	D,0
	LD	E,ANZBLK	;Anz.der 1-K-Bloecke auf einer Spur
	LD	HL,0
ANZKB0:	ADD	HL,DE		;Anz.der 1-K-Bloecke auf den bisher o.k.form.Spuren,
	DJNZ	ANZKB0		;gezaehlt ab Spur 2/Kopf0
	
	LD	A,(VRM)		;falls Vorderseite bereits o.k.,diese Bloecke
	CP	0		;auch addieren
	JR	Z,ANZKB1
	ADD	HL,DE
	
ANZKB1:	PUSH	HL		;hl zwischenspeichern
	LD	A,ANZBLK	;Berechnung der auf dieser Spur bereits o.k.
	LD	HL,KLZ		;geprueften 1-K-Bloecke
	SUB	(HL)
	INC	A		;Nr.des defekten 1-K-Blockes auf der akt.Spur
	POP	HL
	LD	D,0
	LD	E,A
	ADD	HL,DE		;Nr.des defekten 1-K-Blockes ab Spur 2/Kopf 0
	DEC	HL		;Zaehlung bei 0 beginnend
	
	SRL	H		;Errechnen des defekten 2-K-Blockes,indem das hl-Reg.
	RR	L		;durch 2 geteilt wird
	
	LD	(DEFBL),HL	;Blocknummer retten
	
	JP	C,RTEST		;wenn in hl eine ungerade 1-K-Bl.-Nr.stand,pruefen,ob
				;der vorhergehende Bl.,der auch zu dem 2-K-Bl. gehoert,
				;bereits defekt war --> dann kein weiterer Eintrag
FEBEK1:
	LD	HL,DBLLGE
	DEC	(HL)
	DEC	(HL)		;wenn Anz.d.max.zul.def.Bloecke ueberschritten,dann
	JP	M,BREAK2	;Programmabbruch
	
	LD	HL,(BLZEIG)	;Zeiger auf naechste freie Adresse im Merker-Feld
	LD	DE,(DEFBL)	;gerettete Blocknr.in de laden
	LD	(HL),E		;low-Teil abspeichern
	INC	HL
	LD	(HL),D		;high-Teil abspeichern
	INC	HL
	LD	(BLZEIG),HL	;Zeiger auf naechste freie Adresse
	
	LD	HL,SFM		;Merker f.def.128-Byte-Bloecke (f.Dir.-Eintrag.)
	LD	A,(HL)
	ADD	A,16		;16 * 128 = 2 kByte
	LD	(HL),A
	
	JP	WNF		;weiter nach Fehler bei Kontrollesen
	
RTEST:	LD	HL,(BLZEIG)	;Zeiger auf naechste freie Zelle in DBM
	DEC	HL
	LD	D,(HL)		;high-Byte des zuletzt abgespeicherten 2-K-Blockes
	DEC	HL
	LD	E,(HL)		;low-Byte
	LD	HL,(DEFBL)	;zu pruefender 2-K-Block in hl
	XOR	A		;CY loeschen
	SBC	HL,DE		;bei Gleichheit ist der zu pruefende 2-K-Block
	JP	Z,WNF		;bereits als im 1.kByte defekt eingetragen
	JP	FEBEK1		;ungleich --> eintragen
	
;Pruefung,ob Seite 0 o.1
;-----------------------
PRSEIT:	LD	IX,SCHNF
	LD	HL,VRM
	LD	A,(HL)
	CP	0
	JP	NZ,INITB5	;bereits beide Seiten der Spur form.u.kon.-gelesen
	
	LD	(HL),1		;vrm auf 1
	LD	(IX+3),1	;Kopf 1
	LD	HL,F3H1		;ID-Puffer f.Kopf 1
	LD	(PUFFF),HL	;ID-Pufferadr.in Schnittstelle laden
	JP	INITB3		;Seite 1 form. 	
	
;Vorbereitungen zum Formatieren der naechsten Spur o.Programmende
;----------------------------------------------------------------
INITB5:	LD	IX,SCHNF
	LD	HL,VRM
	LD	(HL),0		;vrm auf 0
	INC	(IX+2)		;naechste Spur einstellen
	LD	(IX+3),0	;Kopf 0
	
	CALL	SPINC		;Spur im ID-Puffer inkrement.
	
	LD	HL,F3H0
	LD	(PUFFF),HL	;ID-Pufferadr.in Schnittstelle laden
	
INITB7:	LD	HL,TRACK
	DEC	(HL)
	JP	Z,ENDE		;alle Spuren formatiert
	
	JP	INITB3		;naechste Spur form.
	
	
;Programmabbruch nach ^C o.Fehler nach Form.einer Spur
;-----------------------------------------------------
BREAK1:	LD	DE,BR1TEX	;System-o.Dir.-Spur defekt
	JR	BREAK0
	
BREAK2:	LD	DE,BR2TEX	;zuviele defekte Bloecke
	JR	BREAK0
	
BREAK3:	LD	DE,BR3TEX	;LW nicht bereit
	JR	BREAK0
	
BREAK4:	LD	DE,BR4TEX	;Disk schreibgeschuetzt
	
BREAK0:	
	CALL	ZKAUS
	
BREAK:	LD	DE,BRTEX
	CALL	ZKAUS		;Break-Anzeige
	
	JP	WARM
	
;Anlegen der Sperrdatei errfile.sav,falls die Disk defekte Bloecke hat
;---------------------------------------------------------------------
ENDE:	LD	DE,DBM		;Adresse des DBM
	LD	HL,(BLZEIG)	;Zeiger auf freie Zelle im DBM,bei 0 def.Bl.
				;gleich der Adr.des DBM
	XOR	A		;CY loeschen
	SBC	HL,DE
	JP	Z,WARM		;o.k.--> zur 'Ende ?'-Abfrage
	
	PUSH	HL
	LD	DE,DBTEX	;Anzeige 'Defekte Bloecke:'
	CALL	ZKAUS
	POP	HL
	
	XOR	A		;CY loeschen
	RR	L		;nach Subtraktion in HL Anzahl def.Bloecke * 2 (max. 32)
				;deshalb L durch 2 teilen
	LD	B,L		;B als Zaehler f.anzuzeigende def. 2-K-Bloecke
	LD	HL,DBM
	LD	(BLZEIG),HL	;Zeiger auf auszugebenden Block
	
DBAUSG:	PUSH	BC
	LD	HL,(BLZEIG)
	INC	HL		;high-Byte
	LD	A,(HL)
	CALL	BTSTR		;wandeln in 2 ASCII-Zeichen
	LD	A,(ASZEH)
	CALL	ICONOUT		;Ausgabe eines Zeichens auf BS
	LD	A,(ASEIN)
	CALL	ICONOUT
	LD	HL,(BLZEIG)	;low-Byte
	LD	A,(HL)
	CALL	BTSTR
	LD	A,(ASZEH)
	CALL	ICONOUT
	LD	A,(ASEIN)
	CALL	ICONOUT
	
	LD	HL,(BLZEIG)
	INC	HL
	INC	HL		;Zeiger auf naechsten Block
	LD	(BLZEIG),HL
	
	LD	A,','		;Komma zwischen den Bloecken
	CALL	ICONOUT
	
	POP	BC
	DJNZ	DBAUSG
	
	LD	A,BS		;letztes Komma loeschen
	CALL	ICONOUT
	LD	A,' '
	CALL	ICONOUT
;
	LD	HL,DBUF		;Adresse des hostbuffers im System
	LD	BC,400H		;Laenge des hostbuffers
INIBUF:	LD	(HL),0E5H
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JP	NZ,INIBUF	;Init.buffer mit E5
	
	LD	A,(SFM)		;Anzahl der def 128-Byte-Bloecke
	LD	HL,RECC		;in das 'rc'-Byte des Dir.-Eintrages
	LD	(HL),A
	
	LD	HL,ERRFILE
	LD	DE,DBUF
	LD	BC,32
	LDIR			;Dir.-Eintragung in den write-buffer laden
	
	LD	IX,SCHNR
	LD	(IX),50H	;Befehl: Schreiben
	LD	(IX+2),2	;Spur 2
	LD	(IX+3),0	;Kopf 0
	LD	(IX+4),1	;Sektor 1
;
	LD	A,(HDPBOP)	;Verify-Status zurueck
	LD	H,(IX+13)
	LD	L,(IX+12)
	LD	DE,DPBOPT-DPBDRT
	ADD	HL,DE
	LD	(HL),A
;
	LD	HL,DBUF
	LD	(PUFFR),HL	;hostbufferadr.
	
	CALL	BIFM00
	LD	A,(IX+14)
	AND	A
	JP	NZ,BREAK1
	
;Programmabschluss: Abfrage ob neuer Durchlauf oder Ende
;-------------------------------------------------------
WARM	LD	A,(LWOK)	;gueltige log. LW-Eingabe ?
	AND	A
	JR	Z,WARM2	 	; Nein-->
;
	LD	IX,SCHNR
	LD	A,(HDPBOP)	;Verify-Status zurueck
	LD	H,(IX+13)
	LD	L,(IX+12)
	LD	DE,DPBOPT-DPBDRT
	ADD	HL,DE
	LD	(HL),A
;
WARM2	LD	DE,ENDEQ
	CALL	ZKAUS		;Abfrage ob neuer Durchlauf oder Ende
	
	CALL	TEIN		;warten auf 'J':-->neuer Durchlauf
				; andere Taste:-->abbrechen
	RES	5,A		;Grossbuchstaben erzeugen
	CP	'J'
	JP	Z,INITB0	;Neustart des Programms
;
	RET
	
	
;Unterprogramme
;**************
	
;Nullsetzen aller Spurnummern in den akt.ID-Puffern
;Initialisieren der Schnittstellen
;--------------------------------------------------
SP0:	LD	B,10		;Anzahl Sektoren auf beiden Seiten der Disk
	LD	DE,4
	LD	HL,F3H0		;Adr.des 1.ID-Feldes
SP01:	LD	(HL),0
	ADD	HL,DE
	DJNZ	SP01
	NOP
FO1024:	LD	IX,SCHNR
	LD	IY,SCHNF
	LD	A,73H		;Befehl Kontrollesen nach Format.
	LD	(IX),A
	LD	A,0
	LD	(IY+2),A	;Spur 0
	LD	(IY+3),A	;Kopf 0
	LD	A,1
	LD	(IX+4),A	;1.zu behandelnder Sektor
;
	LD	HL,DBFLG	;Puffer DBUF ungueltig machen !
	RES	DBFWR,(HL)
	LD	HL,DBDEV
	LD	(HL),0FFH
	LD	HL,DBNB
	LD	(HL),0FFH
;
	LD	HL,DBUF
	LD	(PUFFR),HL	;Read-Pufferadr.laden
	LD	HL,F3H0
	LD	(PUFFF),HL	;Format-Pufferadr.laden
	RET
	
;Inkrementieren aller Spurnummern in den akt.ID-Puffern
;------------------------------------------------------
SPINC:	LD	B,10
	LD	DE,4
	LD	HL,F3H0
SPINC1:	INC	(HL)
	LD	A,(HL)		;Spur in A
	ADD	HL,DE
	DJNZ	SPINC1
;
	CP	2
	RET	C		;Systemspur-->RET
	LD	A,0E5H		;Datenspuren mit 0E5H
	LD	(SCHNF+4),A	; initialisieren
	RET
	
;Konvertierung A / 3 stell Dez-Anzeige
;---------------------------------------------------
KON:	LD	C,100
	CALL	DEZA
	LD	C,10
	CALL	DEZA
	LD	C,1
;
DEZA	LD	B,0
DEZ1	SUB	C
	JR	C,DEZ2
	INC	B
	JR	DEZ1
DEZ2	ADD	A,C
	PUSH	AF
	LD	A,B
	ADD	A,'0'
	CALL	ICONOUT
	POP	AF
	RET
	
;Umwandlung Zahl in A in 2 ASCII-Zeichen
;---------------------------------------------------
BTSTR:	LD	B,A		;Retten A
	AND	0F0H		;High-Tetrade
	RRCA
	RRCA
	RRCA
	RRCA
	CP	10
BS01:	JP	P,BS1P
	OR	30H		;0..9
	JP	BS1
BS1P:	ADD	A,'A'-10	;A..F
BS1:	LD	(ASZEH),A
	LD	A,B
	AND	0FH		;Low-Tetrade
	CP	10
BS11:	JP	P,BS2P
	OR	30H
	JP	BS2
BS2P:	ADD	A,'A'-10
BS2:	LD	(ASEIN),A
	RET
;
;Ausgabe Zeichenkette auf BS (Ende = 0H)
;---------------------------------------
ZKAUS	LD	A,(DE)
	OR	A
	RET	Z
	PUSH	DE
	CALL	ICONOUT
	POP	DE
	INC	DE
	JR	ZKAUS
;
;Tastatureigabe (mit Vorloeschen Ringpuffer u. Anzeige)
;----------------------------------------------------------
;
TEIN	CALL	LORIPU
	CALL	ICONIN
	JP	ICONOUT
;
;Schnittstellen f.RD/WR und Form
;Grundeinstellung der Werte auf das Standardformat 5 * 1024
;----------------------------------------------------------
SCHNR0:	DEFB	73H		;(ix+0)	Befehl
	DEFB	0		;(ix+1)	Laufwerk
	DEFB	0		;(ix+2)	Spur
	DEFB	0		;(ix+3)	Kopf
	DEFB	1		;(ix+4)	Sektor
	DEFB	3		;(ix+5)	rel.Datenfeldlaenge
	DEFB	38H		;(ix+6)	Gap 3
	DEFB	1		;(ix+7)	Sektoranzahl
	DEFB	1		;(ix+8)	Verfahren (FM/MFM)
	DEFB	1		;(ix+9)	Schritte/Spur
PUFFR0:	DEFB	0		;(ix+10) Puffadr.(low)
	DEFB	0		;(ix+11) Puffadr.(high)
	DEFW	0		;(ix+12) DRPB (low)
				;(ix+13) DRPB (high)
	DEFB	0		;(ix+14) Status
;
SCHNF0:	DEFB	51H		;(ix+0)	Befehl
	DEFB	0		;(ix+1)	Laufwerk
	DEFB	0		;(ix+2)	Spur
	DEFB	0		;(ix+3)	Kopf
	DEFB	53H		;(ix+4)	Sektorinhalt (Systemspuren)
	DEFB	3		;(ix+5)	rel.Datenfeldlaenge
	DEFB	74H		;(ix+6)	Gap 3
	DEFB	5		;(ix+7)	Sektoranzahl
	DEFB	1		;(ix+8)	Verfahren (FM/MFM)
	DEFB	1		;(ix+9)	Schritte/Spur
PUFFF0:	DEFB	0		;(ix+10) Puffadr.(low)
	DEFB	0		;(ix+11) Puffadr.(high)
	DEFW	0		;(ix+12) DRPB (low)
				;(ix+13) DRPB (high)
	DEFB	0		;(ix+14) Status
;
;Puffer	f.ID-Felder:
;-------------------
F3H00:	DFB	0,0,1,3		;C,H,R,N f.Sektor 1,Kopf 0,Spur 0 (C wird bei
	DFB	0,0,4,3		;	   Sektor 4 /jedem Aufruf aktualisiert)
	DFB	0,0,2,3		;		  2
	DFB	0,0,5,3		;		  5	
	DFB	0,0,3,3		;		  3
F3H10:	DFB	0,1,1,3		;C,H,R,N f.Sektor 1,Kopf 1,Spur 0 (s.oben)
	DFB	0,1,4,3
	DFB	0,1,2,3
	DFB	0,1,5,3
F3H11:	DFB	0,1,3,3
;vorbereitete Directory-Eintragung zum Anlegen der Sperrdatei errfile.sav
;------------------------------------------------------------------------
ERRFI0	DEFB	17		;User 17
	DEFM	'ERRFILE '
	DFB	0D3H,0C1H,56H	;errfile.sav mit gesetztem Bit 7 im Typ
EXTZA0	DEFB	0		;Extentzaehler (hier 0)
	DEFW	0		;Byte 13/14 des Dir.-Eintrages
RECC0	DEFB	0		;Zaehler f.die belegten 128-Byte-Saetze (0..80h)
DBM0	DFW	0,0,0,0
	DFW	0,0,0,0
DBMEN0	EQU	$-1
;Bildschirmausschriften
;**********************
AMENUE	DFB	CR,LF
	DEFM	'Formatieren im LW (A)/B/C: '
	DEFB	0
STECK:	DFB	CR,LF,LF
	DEFM	'Diskette stecken <ENTER>: '
	DEFB	0
WARN:	DFB	CR,LF,LF
	DEFM	'WARNUNG !!!'
	DFB	CR,LF
	DEFM	'Gesamte Diskette wird geloescht! J/(N):'
	DEFB	0
FANZ:	DEFB	CR
	DEFM	'Formatieren auf Spur: '
	DEFB	0
DBTEX:	DFB	CR,LF,LF
	DEFM	'Nummern der defekten Bloecke:'
	DFB	CR,LF,0
ENDEQ:	DFB	CR,LF
	DEFM	'Noch einmal? J/(N): '
	DEFB	0
BR1TEX:	DFB	CR,LF
	DEFM	'System- oder Directory-Spur defekt'
	DEFB	0
BR2TEX:	DFB	CR,LF
	DEFM	'Zu viele defekte Bloecke'
	DEFB	0
BR3TEX:	DFB	CR,LF
	DEFM	'LW nicht bereit'
	DEFB	0
BR4TEX:	DFB	CR,LF
	DEFM	'Diskette hat Schreibschutz'
	DEFB	0
BRTEX:	DFB	CR,LF,LF
 	DEFM	'** ABBRUCH **'
FANZ1	DFB	CR,LF,LF,0
;**************************************
