;*****************************************
;UP zum Bildschirmabzug (im RBASIC)
;
;File: BILDCOPY.S
;Stand: 03.05.89 / Ludewig
;*****************************************
ESCCHR	EQU	1BH
REZEMU	EQU	2DH
RDVRM	EQU	4AH
L1CALL	EQU	159H
	GLOBAL	BICOP
	EXTERNAL	ERDEVI	PRTOUT	PRTREI
;*****************************************
;IN : -
;OUT: NC: Ausgabe ok
;     sonst: Falscher Drucker, nicht 8 Datenbit oder CTRL-STOP
;            RBASIC: Hart zu ERDEVI
;	     SCP: RET C
;REG: AF,BC,DE
;     HL (nur bei SCP)
;
BICOP	EI			;EI (da Longcall mit DI endet)
	LD	A,(V24FO)	;8 Bit?
	BIT	7,A
	JP	Z,BICO04	; Nein-->
;
	LD	A,(DRUTYP)	;Richtiger Drucker?
	BIT	1,A
	JP	Z,BICO05	; Ja-->
	JP	BICO04
;	----------------------------------
BICO01	POP	HL		; (3) Stack leeren
BICO02	POP	HL		; (2)
	POP	HL		; (1)
BICO04	CALL	XPRTO2		;RET bei SCP
	LD	IX,ERDEVI
	JP	L1CALL		;RBASIC-Fehler
;=========================================
BICO05	PUSH	HL		; (1)
	LD	A,(WIDTH)
BICO08:	PUSH	AF		;BS-Spaltenzahl (2)
;-----------------------------------------
	LD	A,(DRUTYP)
	BIT	0,A
	LD	DE,IGRM	 	;Grafikmode IBM (ESC K)
	JR	Z,BICO12
	LD	DE,EGRM	 	;Grafikmode EPSON (ESC * 5)
BICO12	CALL	DRTREI
	JR	C,BICO02
;
	LD	A,(SCRNRV)
	BIT	3,A
	LD	DE,25*8		;Screen 0-3,5
	JR	Z,BICO18
	LD	DE,25*11	;Screen 8,9
BICO18:	LD	A,E
	CALL	PRTREI		;Grafikanzahl
	JR	C,BICO02
	LD	A,D
	CALL	PRTREI
	JR	C,BICO02
;	----------------------------------
	LD	HL,(VVRAM)
	POP	AF		;(2)
	PUSH	AF		;(2)
	LD	E,A
	LD	D,0
	DEC	DE
	ADD	HL,DE		;HL=BWS-Adr
;	==================================
	LD	A,(SCRNRV)
	AND	6
	LD	A,200		;BS-Grafikzeilen
	JR	NZ,BICO20
	LD	A,(FKTANZ)
	ADD	A,25		;BS-Alphazeilen
BICO20:	PUSH	AF		; (3)
;	----------------------------------
	PUSH	HL		; (4)
	CALL	BWSOUT		;Druck
	POP	HL		; (4)
	JR	C,BICO01
;	----------------------------------
	LD	DE,(WIDTH)
	ADD	HL,DE
	POP	AF		; (3)
	DEC	A
	JR	NZ,BICO20	;-->Naechste BS-Zeile
;	==================================
	LD	A,(SCRNRV)
	AND	6		;Alpha-Screen?
	JR	NZ,BICO40	; Nein-->
	LD	A,(FKTANZ)	;Mit Keyzeile?
	AND	A
	JR	Z,BICO40	; Nein-->
;	----------------------------------
	POP	AF		; (2)
	PUSH	AF		; (2)
	LD	L,A
	LD	H,0
	LD	A,(FTSHI)
	AND	A
	LD	DE,0FF40H-1	;Key 1-5
	JR	NZ,BICO30
	LD	DE,0FF90H-1	;Key 6-10
BICO30:	ADD	HL,DE
	CALL	BWSOUT		; Drucken
	JP	C,BICO02
;	==================================
BICO40:	LD	A,0DH		;CR + evtl. linker Rand
	CALL	PRTOUT
	JP	C,BICO02
	LD	DE,NEZE
	CALL	DRTREI		;Neue Druckzeile
	JP	C,BICO02
;	----------------------------------
	LD	A,(SCRNRV)
	CP	5
	JR	NZ,BICO42
;
	POP	AF		; (2)
	DEC	A		;Screen 5: A=A-2
	JR	BICO43
;
BICO42	POP	AF		; (2)
BICO43	DEC	A		;sonst: A=A-1
	JP	NZ,BICO08	;-->naechste BS-Spalte
;=========================================
	POP	HL		; (1)
	RET			;OK-->RET
;*****************************************
IGRM	DEFB	2		;Grafikmode IBM: 60 Punkte/Zoll
	DEFB	ESCCHR
	DEFB	'K'
;
EGRM	DEFB	3		;Gafikmode EPSON: 72 Punkte/Zoll
	DEFB	ESCCHR		; (Plottergrafik 1:1)
	DEFB	'*'
	DEFB	5
;
NEZE:	DEFB	3		;Neue Zeile
	DEFB	ESCCHR		; Vorschub 24/216 Zoll
	DEFB	'J'		;  = 8 Nadeln
	DEFB	24
;*****************************************
;1 Doppelbyte aus BWS lesen und drucken
;IN: HL=Adr. BWS
;OUT:NC: ok
;     C: CTRL-STOP
;REG:AF,BC,DE,HL
;
BWSOUT:	CALL	RDVRM		;BWS lesen
;	----------------------------------
	LD	A,(SCRNRV)
	CP	5
	JR	Z,BWSO30	;Screen5-->
	BIT	1,A		;Alpha-Screen?
	LD	A,C
	JR	NZ,BWSO20	; Nein-->
;=========================================
	CALL	REZEMU		;Zeichenmuster lesen
;	----------------------------------
	LD	DE,ZEIPUF
	LD	B,8
	CALL	DRTRE6		;Ausgabe 8 Byte Alpha
	RET	C
;	----------------------------------
	LD	DE,ZAB
	LD	A,(SCRNRV)
	BIT	3,A		;Screen 8,9?
	JP	NZ,DRTREI	; Ja-->Zeilenabstand
	RET
;=========================================
BWSO20:	OR	B		;Ausgabe 1 Byte Grafik
	JP	PRTREI
;=========================================
BWSO30	PUSH	HL
	LD	D,0		;Druckerbyte
	CALL	PIXEL		;1. x 4 Bit
	POP	HL
;	----------------------------------
	DEC	HL
	CALL	RDVRM		;2. x 4 Bit
	CALL	PIXEL
;	----------------------------------
	LD	A,D
	JP	PRTREI		;Ausgabe 1 Byte Multicolor
;=========================================
ZAB:	DEFB	3		;Zeilenabstand
	DEFW	0
	DEFB	0
;*****************************************
;Direktausgabe auf Drucker
;IN: DE=Adr. ZK (1.Byte=Laenge)
;OUT:NC: Ausgabe ok / DE weiter
;     C: CTRL-STOP
;REG:AF
;
DRTREI:	LD	A,(DE)
	LD	B,A
DRTRE5:	INC	DE
DRTRE6:	LD	A,(DE)	;ENTRY:Laenge in B
	CALL	PRTREI
	RET	C
	DJNZ	DRTRE5
	RET
;*****************************************
;Wandlung 1 Doppelbyte aus BWS in 4 Druckpunkte
;IN: C,B: Doppelbyte aus BWS (nach RDVRM)
;      D: Druckpunkte
;OUT: D: um 4 Bit linksverschoben
;	 Bit 3-0 entspr. Doppelbyte
;REG:AF,BC,D,E,H
;
PIXEL	LD	A,(VIREG3)
	AND	0FH
	LD	E,A		;E=Hintergrundfarbe
	LD	H,4
;	----------------------------------
PIX10	XOR	A
	RLC	D		;D links verschieben
;	----------------------------------
	BIT	7,C
	JR	Z,PIX20
	SET	3,A
;	----------------------------------
PIX20	BIT	3,C
	JR	Z,PIX30
	SET	2,A
;	----------------------------------
PIX30	BIT	7,B
	JR	Z,PIX40
	SET	1,A
;	----------------------------------
PIX40	BIT	3,B
	JR	Z,PIX50
	SET	0,A
;	----------------------------------
PIX50	CP	E		;A=Hintergrundfarbe?
	JR	Z,PIX60
	SET	0,D		; Nein: Druckpunkt setzen
;	----------------------------------
PIX60	RLC	C
	RLC	B
	DEC	H
	JR	NZ,PIX10
;	----------------------------------
	RET
;*****************************************
